/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 *
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */
package net.jdcloud.HufuStorage;

import com.google.gson.Gson;
import com.jdcloud.sdk.apim.auth.CredentialsProvider;
import com.jdcloud.sdk.apim.auth.StaticCredentialsProvider;
import com.jdcloud.sdk.apim.client.Environment;
import com.jdcloud.sdk.apim.http.ContentType;
import com.jdcloud.sdk.apim.http.HttpRequestConfig;
import com.jdcloud.sdk.apim.http.Protocol;
import net.jdcloud.HufuStorage.client.HufuStorageClient;
import net.jdcloud.HufuStorage.model.*;
import net.jdcloud.HufuStorage.model.jingdonghufudeliveryordercreate.DeliveryOrderCreateRequest;
import net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderquery.DeliveryOrderQueryRequest;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Demo
 */
public class Demo {

    private static String accessKeyId = "xxx";
    private static String secretKey = "xxx";
    private static CredentialsProvider credentialsProvider = new StaticCredentialsProvider(accessKeyId, secretKey);
    private static HufuStorageClient client = HufuStorageClient.builder()
            .credentialsProvider(credentialsProvider)
            .httpRequestConfig(new HttpRequestConfig.Builder().connectionTimeout(10000).contentType(ContentType.APPLICATION_XML).protocol(Protocol.HTTP).build())
//            .environment(new Environment.Builder().endpoint("hufu-sandbox.jdcloud.com").build()) // 挡板地址，仅支持http
            .environment(new Environment.Builder().endpoint("hufu.cn-north-1.jdcloud-api.net").build()) // 线上环境公网地址
            .build();

    public static void main(String[] args) {

        JingdongHufuDeliveryorderCreateRequest jingdongHufuDeliveryorderCreateRequest = new JingdongHufuDeliveryorderCreateRequest();
        jingdongHufuDeliveryorderCreateRequest.setAppKey(accessKeyId);
        jingdongHufuDeliveryorderCreateRequest.setCustomerId("xxx");
        jingdongHufuDeliveryorderCreateRequest.setMethod("jingdong.hufu.deliveryorder.create");
        jingdongHufuDeliveryorderCreateRequest.setFormat("json");//固定值
        jingdongHufuDeliveryorderCreateRequest.setV("1.0");//固定值
        jingdongHufuDeliveryorderCreateRequest.setSignMethod("md5");//固定值
        jingdongHufuDeliveryorderCreateRequest.setTimestamp(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
        DeliveryOrderCreateRequest deliveryOrderCreateRequest = new DeliveryOrderCreateRequest();
        deliveryOrderCreateRequest = new Gson().fromJson("{\"deliveryOrder\":{\"arAmount\":\"0\",\"buyerMessage\":\"\",\"buyerNick\":\"jzkdwp1201\",\"createTime\":\"2021-06-24 10:17:34\",\"deliveryOrderCode\":\"XS0121062002519001301-3\",\"discountAmount\":\"0.00\",\"freight\":\"0.00\",\"gotAmount\":\"0.01\",\"isUrgency\":\"N\",\"itemAmount\":\"0.01\",\"logisticsCode\":\"\",\"logisticsName\":\"顺丰快递1\",\"operateTime\":\"2021-05-31 15:16:20\",\"orderType\":\"JYCK\",\"payTime\":\"2021-05-31 15:16:27\",\"placeOrderTime\":\"2021-05-31 15:16:20\",\"preDeliveryOrderCode\":\"\",\"preDeliveryOrderId\":\"\",\"receiverInfo\":{\"area\":\"萧山区\",\"city\":\"杭州\",\"detailAddress\":\"浙江杭州市萧山区城区金城路与金山路交叉口东南200米金地德圣中心8幢\",\"mobile\":\"$R6SPA4db4XalhoH0w8Ox2Yt3qtkZ1B5fxtKU1cHdiww=$UyUGC7Kw1deQ7AWz30br7pl8xcEox9FN9OX7aAzPeSbWMSxBt4+PCFlwEYgyo2TURgdD3RSwCcyrf3iRc5mqYcM0MpHQxHVuGuIH+vw=*CgkIARCtHCABKAESPgo8oaep+anvvehEDpGtIWoZPVvliApjeRknGtDINyGNgWsyA9MM6TNfkf4O8NrMs+IM8FShw/6WDsmOc4xFGgA=$1$$\",\"name\":\"蒋道理\",\"province\":\"浙江\",\"tel\":\"$R6SPA4db4XalhoH0w8Ox2Yt3qtkZ1B5fxtKU1cHdiww=$UyUGC7Kw1deQ7AWz30br7pl8xcEox9FN9OX7aAzPeSbWMSxBt4+PCFlwEYgyo2TURgdD3RSwCcyrf3iRc5mqYcM0MpHQxHVuGuIH+vw=*CgkIARCtHCABKAESPgo8oaep+anvvehEDpGtIWoZPVvliApjeRknGtDINyGNgWsyA9MM6TNfkf4O8NrMs+IM8FShw/6WDsmOc4xFGgA=$1$$\"},\"remark\":\"\",\"sellerMessage\":\"【已审核】\",\"senderInfo\":{\"area\":\"朝阳区\",\"city\":\"北京\",\"detailAddress\":\"asdadadasd\",\"mobile\":\"123122\",\"name\":\"钻石卡\",\"province\":\"北京\",\"tel\":\"123122\"},\"serviceFee\":\"0\",\"shopNick\":\"服务市场测试店铺\",\"sourcePlatformCode\":\"JOS\",\"sourcePlatformName\":\"JOS\",\"totalAmount\":\"0.01\",\"warehouseCode\":\"1023433901\"},\"orderLines\":[{\"actualPrice\":\"0.01\",\"inventoryType\":\"ZP\",\"itemCode\":\"S1000137491\",\"itemId\":\"erpwms商品0425\",\"orderLineNo\":\"101295435736\",\"ownerCode\":\"CBonsGuanycTest\",\"planQty\":1,\"sourceOrderCode\":\"197060900008\",\"subSourceOrderCode\":\"203019282416\"}]}", DeliveryOrderCreateRequest.class);
        jingdongHufuDeliveryorderCreateRequest.setDeliveryOrderCreateRequest(deliveryOrderCreateRequest);
        JingdongHufuDeliveryorderCreateResponse jingdongHufuDeliveryorderCreateResponse = client.jingdongHufuDeliveryorderCreate(jingdongHufuDeliveryorderCreateRequest);

        JingdongHufuDeliveryorderQueryRequest jingdongHufuDeliveryorderQueryRequest = new JingdongHufuDeliveryorderQueryRequest();
        JingdongHufuDeliveryorderQueryResponse jingdongHufuDeliveryorderQueryResponse = client.jingdongHufuDeliveryorderQuery(jingdongHufuDeliveryorderQueryRequest);

        JingdongHufuEntryorderQueryRequest jingdongHufuEntryorderQueryRequest = new JingdongHufuEntryorderQueryRequest();
        JingdongHufuEntryorderQueryResponse jingdongHufuEntryorderQueryResponse = client.jingdongHufuEntryorderQuery(jingdongHufuEntryorderQueryRequest);

        JingdongHufuReturnorderCreateRequest jingdongHufuReturnorderCreateRequest = new JingdongHufuReturnorderCreateRequest();
        JingdongHufuReturnorderCreateResponse jingdongHufuReturnorderCreateResponse = client.jingdongHufuReturnorderCreate(jingdongHufuReturnorderCreateRequest);

        JingdongHufuStockoutCreateRequest jingdongHufuStockoutCreateRequest = new JingdongHufuStockoutCreateRequest();
        JingdongHufuStockoutCreateResponse jingdongHufuStockoutCreateResponse = client.jingdongHufuStockoutCreate(jingdongHufuStockoutCreateRequest);

        JingdongHufuDeliveryorderBatchconfirmRequest jingdongHufuDeliveryorderBatchconfirmRequest = new JingdongHufuDeliveryorderBatchconfirmRequest();
        JingdongHufuDeliveryorderBatchconfirmResponse jingdongHufuDeliveryorderBatchconfirmResponse = client.jingdongHufuDeliveryorderBatchconfirm(jingdongHufuDeliveryorderBatchconfirmRequest);

        JingdongHufuSnReportRequest jingdongHufuSnReportRequest = new JingdongHufuSnReportRequest();
        JingdongHufuSnReportResponse jingdongHufuSnReportResponse = client.jingdongHufuSnReport(jingdongHufuSnReportRequest);

        JingdongHufuEntryorderConfirmRequest jingdongHufuEntryorderConfirmRequest = new JingdongHufuEntryorderConfirmRequest();
        JingdongHufuEntryorderConfirmResponse jingdongHufuEntryorderConfirmResponse = client.jingdongHufuEntryorderConfirm(jingdongHufuEntryorderConfirmRequest);

        JingdongHufuStockchangeReportRequest jingdongHufuStockchangeReportRequest = new JingdongHufuStockchangeReportRequest();
        JingdongHufuStockchangeReportResponse jingdongHufuStockchangeReportResponse = client.jingdongHufuStockchangeReport(jingdongHufuStockchangeReportRequest);

        JingdongHufuReturnorderConfirmRequest jingdongHufuReturnorderConfirmRequest = new JingdongHufuReturnorderConfirmRequest();
        JingdongHufuReturnorderConfirmResponse jingdongHufuReturnorderConfirmResponse = client.jingdongHufuReturnorderConfirm(jingdongHufuReturnorderConfirmRequest);

        JingdongHufuSingleitemSynchronizeRequest jingdongHufuSingleitemSynchronizeRequest = new JingdongHufuSingleitemSynchronizeRequest();
        JingdongHufuSingleitemSynchronizeResponse jingdongHufuSingleitemSynchronizeResponse = client.jingdongHufuSingleitemSynchronize(jingdongHufuSingleitemSynchronizeRequest);

        JingdongHufuStockoutConfirmRequest jingdongHufuStockoutConfirmRequest = new JingdongHufuStockoutConfirmRequest();
        JingdongHufuStockoutConfirmResponse jingdongHufuStockoutConfirmResponse = client.jingdongHufuStockoutConfirm(jingdongHufuStockoutConfirmRequest);

        JingdongHufuInventoryQueryRequest jingdongHufuInventoryQueryRequest = new JingdongHufuInventoryQueryRequest();
        JingdongHufuInventoryQueryResponse jingdongHufuInventoryQueryResponse = client.jingdongHufuInventoryQuery(jingdongHufuInventoryQueryRequest);

        JingdongHufuOrderCancelRequest jingdongHufuOrderCancelRequest = new JingdongHufuOrderCancelRequest();
        JingdongHufuOrderCancelResponse jingdongHufuOrderCancelResponse = client.jingdongHufuOrderCancel(jingdongHufuOrderCancelRequest);

        JingdongHufuInventoryReportRequest jingdongHufuInventoryReportRequest = new JingdongHufuInventoryReportRequest();
        JingdongHufuInventoryReportResponse jingdongHufuInventoryReportResponse = client.jingdongHufuInventoryReport(jingdongHufuInventoryReportRequest);

        JingdongHufuItemsSynchronizeRequest jingdongHufuItemsSynchronizeRequest = new JingdongHufuItemsSynchronizeRequest();
        JingdongHufuItemsSynchronizeResponse jingdongHufuItemsSynchronizeResponse = client.jingdongHufuItemsSynchronize(jingdongHufuItemsSynchronizeRequest);

        JingdongHufuDeliveryorderBatchcreateAnswerRequest jingdongHufuDeliveryorderBatchcreateAnswerRequest = new JingdongHufuDeliveryorderBatchcreateAnswerRequest();
        JingdongHufuDeliveryorderBatchcreateAnswerResponse jingdongHufuDeliveryorderBatchcreateAnswerResponse = client.jingdongHufuDeliveryorderBatchcreateAnswer(jingdongHufuDeliveryorderBatchcreateAnswerRequest);

        JingdongHufuStoreprocessCreateRequest jingdongHufuStoreprocessCreateRequest = new JingdongHufuStoreprocessCreateRequest();
        JingdongHufuStoreprocessCreateResponse jingdongHufuStoreprocessCreateResponse = client.jingdongHufuStoreprocessCreate(jingdongHufuStoreprocessCreateRequest);

        JingdongHufuStoreprocessConfirmRequest jingdongHufuStoreprocessConfirmRequest = new JingdongHufuStoreprocessConfirmRequest();
        JingdongHufuStoreprocessConfirmResponse jingdongHufuStoreprocessConfirmResponse = client.jingdongHufuStoreprocessConfirm(jingdongHufuStoreprocessConfirmRequest);

        JingdongHufuTransferorderQueryRequest jingdongHufuTransferorderQueryRequest = new JingdongHufuTransferorderQueryRequest();
        JingdongHufuTransferorderQueryResponse jingdongHufuTransferorderQueryResponse = client.jingdongHufuTransferorderQuery(jingdongHufuTransferorderQueryRequest);

        JingdongHufuTransferorderCreateRequest jingdongHufuTransferorderCreateRequest = new JingdongHufuTransferorderCreateRequest();
        JingdongHufuTransferorderCreateResponse jingdongHufuTransferorderCreateResponse = client.jingdongHufuTransferorderCreate(jingdongHufuTransferorderCreateRequest);

        JingdongHufuTransferorderReportRequest jingdongHufuTransferorderReportRequest = new JingdongHufuTransferorderReportRequest();
        JingdongHufuTransferorderReportResponse jingdongHufuTransferorderReportResponse = client.jingdongHufuTransferorderReport(jingdongHufuTransferorderReportRequest);

        JingdongHufuSingleitemQueryRequest jingdongHufuSingleitemQueryRequest = new JingdongHufuSingleitemQueryRequest();
        JingdongHufuSingleitemQueryResponse jingdongHufuSingleitemQueryResponse = client.jingdongHufuSingleitemQuery(jingdongHufuSingleitemQueryRequest);

        JingdongHufuShopSynchronizeRequest jingdongHufuShopSynchronizeRequest = new JingdongHufuShopSynchronizeRequest();
        JingdongHufuShopSynchronizeResponse jingdongHufuShopSynchronizeResponse = client.jingdongHufuShopSynchronize(jingdongHufuShopSynchronizeRequest);

        JingdongHufuWarehouseinfoSynchronizeRequest jingdongHufuWarehouseinfoSynchronizeRequest = new JingdongHufuWarehouseinfoSynchronizeRequest();
        JingdongHufuWarehouseinfoSynchronizeResponse jingdongHufuWarehouseinfoSynchronizeResponse = client.jingdongHufuWarehouseinfoSynchronize(jingdongHufuWarehouseinfoSynchronizeRequest);

        JingdongHufuEntryorderCreateRequest jingdongHufuEntryorderCreateRequest = new JingdongHufuEntryorderCreateRequest();
        JingdongHufuEntryorderCreateResponse jingdongHufuEntryorderCreateResponse = client.jingdongHufuEntryorderCreate(jingdongHufuEntryorderCreateRequest);

        JingdongHufuCombineItemQueryRequest jingdongHufuCombineItemQueryRequest = new JingdongHufuCombineItemQueryRequest();
        JingdongHufuCombineItemQueryResponse jingdongHufuCombineItemQueryResponse = client.jingdongHufuCombineItemQuery(jingdongHufuCombineItemQueryRequest);

        JingdongHufuOrderProcessQueryRequest jingdongHufuOrderProcessQueryRequest = new JingdongHufuOrderProcessQueryRequest();
        JingdongHufuOrderProcessQueryResponse jingdongHufuOrderProcessQueryResponse = client.jingdongHufuOrderProcessQuery(jingdongHufuOrderProcessQueryRequest);

        JingdongHufuCombineItemDeleteRequest jingdongHufuCombineItemDeleteRequest = new JingdongHufuCombineItemDeleteRequest();
        JingdongHufuCombineItemDeleteResponse jingdongHufuCombineItemDeleteResponse = client.jingdongHufuCombineItemDelete(jingdongHufuCombineItemDeleteRequest);

        JingdongHufuCombineItemSynchronizeRequest jingdongHufuCombineItemSynchronizeRequest = new JingdongHufuCombineItemSynchronizeRequest();
        JingdongHufuCombineItemSynchronizeResponse jingdongHufuCombineItemSynchronizeResponse = client.jingdongHufuCombineItemSynchronize(jingdongHufuCombineItemSynchronizeRequest);

        JingdongHufuOrderPendingRequest jingdongHufuOrderPendingRequest = new JingdongHufuOrderPendingRequest();
        JingdongHufuOrderPendingResponse jingdongHufuOrderPendingResponse = client.jingdongHufuOrderPending(jingdongHufuOrderPendingRequest);

        JingdongHufuDeliveryorderBatchcreateRequest jingdongHufuDeliveryorderBatchcreateRequest = new JingdongHufuDeliveryorderBatchcreateRequest();
        JingdongHufuDeliveryorderBatchcreateResponse jingdongHufuDeliveryorderBatchcreateResponse = client.jingdongHufuDeliveryorderBatchcreate(jingdongHufuDeliveryorderBatchcreateRequest);

        JingdongHufuOrderprocessReportRequest jingdongHufuOrderprocessReportRequest = new JingdongHufuOrderprocessReportRequest();
        JingdongHufuOrderprocessReportResponse jingdongHufuOrderprocessReportResponse = client.jingdongHufuOrderprocessReport(jingdongHufuOrderprocessReportRequest);

        JingdongHufuDeliveryorderConfirmRequest jingdongHufuDeliveryorderConfirmRequest = new JingdongHufuDeliveryorderConfirmRequest();
        JingdongHufuDeliveryorderConfirmResponse jingdongHufuDeliveryorderConfirmResponse = client.jingdongHufuDeliveryorderConfirm(jingdongHufuDeliveryorderConfirmRequest);

    }
}
