/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */
package net.jdcloud.HufuStorage.client;

import com.jdcloud.sdk.apim.JdcloudSdkException;
import com.jdcloud.sdk.apim.auth.CredentialsProvider;
import com.jdcloud.sdk.apim.client.Environment;
import com.jdcloud.sdk.apim.client.Jdcloud;
import com.jdcloud.sdk.apim.client.JdcloudClient;
import com.jdcloud.sdk.apim.client.JdcloudValidateException;
import com.jdcloud.sdk.apim.http.HttpRequestConfig;
import net.jdcloud.HufuStorage.model.*;

/**
 * https://xzvxovp87wyp.cn-north-1.jdcloud-api.net,xzvxovp87wyp.cn-north-1.vpc.jdcloud-api.net
 */
public class HufuStorageClient extends JdcloudClient {

    public final static String ApiVersion = "";
    private final static String UserAgentPrefix = "JdcloudSdkJava";
    public final static String ClientVersion = "2.2.9";
    public final static String DefaultEndpoint = "xzvxovp87wyp.cn-north-1.jdcloud-api.net,xzvxovp87wyp.cn-north-1.vpc.jdcloud-api.net";
    public final static String ServiceName = "xzvxovp87wyp";
    public final static String UserAgent = UserAgentPrefix + "/" + ClientVersion + " " + ServiceName + "/" + ApiVersion;
    public final static String REGION_ID = "cn-north-1";

    CredentialsProvider credentialsProvider;
    HttpRequestConfig httpRequestConfig;
    Environment environment = new Environment.Builder().endpoint(DefaultEndpoint).build();

    public CredentialsProvider getCredentialsProvider() {
        return credentialsProvider;
    }

    public HttpRequestConfig getHttpRequestConfig() {
        return httpRequestConfig;
    }

    public Environment getEnvironment() {
        return environment;
    }

    public String getUserAgent() {
        return UserAgent;
    }

    public String getServiceName() {
        return ServiceName;
    }

    public String getVersion() {
        return ApiVersion;
    }
    
    public String getRegionId() {
        return REGION_ID;
    }

    private HufuStorageClient() {

    }

    public static Builder builder() {
        return new DefaultBuilder();
    }
    
    public interface Builder {
        public Builder credentialsProvider(CredentialsProvider provider);
        public Builder environment(Environment environment);
        public Builder httpRequestConfig(HttpRequestConfig config);
        public HufuStorageClient build() throws JdcloudSdkException;
    }

    private static class DefaultBuilder implements Builder {

        private HufuStorageClient HufuStorageClient;

        public DefaultBuilder() {
            HufuStorageClient = new HufuStorageClient();
        }

        public DefaultBuilder credentialsProvider(CredentialsProvider provider) {
            HufuStorageClient.credentialsProvider = provider;
            return this;
        }

        public DefaultBuilder httpRequestConfig(HttpRequestConfig config) {
            HufuStorageClient.httpRequestConfig = config;
            return this;
        }

        public HufuStorageClient build() throws JdcloudSdkException {

            if (HufuStorageClient.credentialsProvider == null) {
                //if credentialsProvider not set, try load jdcloud global default  credentials provider
                HufuStorageClient.credentialsProvider = Jdcloud.defaultInstance().getCredentialsProvider();
            }
            if (HufuStorageClient.httpRequestConfig == null) {
                HufuStorageClient.httpRequestConfig = Jdcloud.defaultInstance().getHttpRequestConfig();
                if (HufuStorageClient.httpRequestConfig == null) {
                    throw new JdcloudValidateException("HufuStorageClient build error: http request config not set");
                }
            }
            return HufuStorageClient;
        }

        public Builder environment(Environment environment) {
            HufuStorageClient.environment = environment;
            return this;
        }
    }
    
    
    /**
     * ERP调用虎符的发货单查询接口，查询发货单详情
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuDeliveryorderQueryResponse jingdongHufuDeliveryorderQuery(JingdongHufuDeliveryorderQueryRequest request) throws JdcloudSdkException {
        return new JingdongHufuDeliveryorderQueryExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用接口，查询入库单信息;
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuEntryorderQueryResponse jingdongHufuEntryorderQuery(JingdongHufuEntryorderQueryRequest request) throws JdcloudSdkException {
        return new JingdongHufuEntryorderQueryExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符的接口,创建退货单信息;该接口和入库单的区别就是该接口是从入库单接口中单独剥离出来的，专门处理退货引起的入 库操作
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuReturnorderCreateResponse jingdongHufuReturnorderCreate(JingdongHufuReturnorderCreateRequest request) throws JdcloudSdkException {
        return new JingdongHufuReturnorderCreateExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符接口，创建出库单信息
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuStockoutCreateResponse jingdongHufuStockoutCreate(JingdongHufuStockoutCreateRequest request) throws JdcloudSdkException {
        return new JingdongHufuStockoutCreateExecutor().client(this).execute(request);
    }

    
    /**
     * 发货单批量确认接口
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuDeliveryorderBatchconfirmResponse jingdongHufuDeliveryorderBatchconfirm(JingdongHufuDeliveryorderBatchconfirmRequest request) throws JdcloudSdkException {
        return new JingdongHufuDeliveryorderBatchconfirmExecutor().client(this).execute(request);
    }

    
    /**
     * WMS调用虎符的接口,在仓库出库单后, 把SN信息回传给ERP
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuSnReportResponse jingdongHufuSnReport(JingdongHufuSnReportRequest request) throws JdcloudSdkException {
        return new JingdongHufuSnReportExecutor().client(this).execute(request);
    }

    
    /**
     * WMS调用接口，回传入库单信息;
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuEntryorderConfirmResponse jingdongHufuEntryorderConfirm(JingdongHufuEntryorderConfirmRequest request) throws JdcloudSdkException {
        return new JingdongHufuEntryorderConfirmExecutor().client(this).execute(request);
    }

    
    /**
     * WMS调用虎符的接口,将库存异动信息回传给ERP
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuStockchangeReportResponse jingdongHufuStockchangeReport(JingdongHufuStockchangeReportRequest request) throws JdcloudSdkException {
        return new JingdongHufuStockchangeReportExecutor().client(this).execute(request);
    }

    
    /**
     * 退货入库单确认接口
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuReturnorderConfirmResponse jingdongHufuReturnorderConfirm(JingdongHufuReturnorderConfirmRequest request) throws JdcloudSdkException {
        return new JingdongHufuReturnorderConfirmExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符的接口,同步商品信息给WMS
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuSingleitemSynchronizeResponse jingdongHufuSingleitemSynchronize(JingdongHufuSingleitemSynchronizeRequest request) throws JdcloudSdkException {
        return new JingdongHufuSingleitemSynchronizeExecutor().client(this).execute(request);
    }

    
    /**
     * 货品出库后，WMS将状态回传给ERP
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuStockoutConfirmResponse jingdongHufuStockoutConfirm(JingdongHufuStockoutConfirmRequest request) throws JdcloudSdkException {
        return new JingdongHufuStockoutConfirmExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符的接口,查询商品的库存量
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuInventoryQueryResponse jingdongHufuInventoryQuery(JingdongHufuInventoryQueryRequest request) throws JdcloudSdkException {
        return new JingdongHufuInventoryQueryExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符的接口,取消创建单据操作。场景介绍：ERP主动发起取消某些创建的单据。如入库单、出库单、退货单等；所有的场景
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuOrderCancelResponse jingdongHufuOrderCancel(JingdongHufuOrderCancelRequest request) throws JdcloudSdkException {
        return new JingdongHufuOrderCancelExecutor().client(this).execute(request);
    }

    
    /**
     * 发货单创建接口
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuDeliveryorderCreateResponse jingdongHufuDeliveryorderCreate(JingdongHufuDeliveryorderCreateRequest request) throws JdcloudSdkException {
        return new JingdongHufuDeliveryorderCreateExecutor().client(this).execute(request);
    }

    
    /**
     * WMS调用虎符的接口,将库存盘点情况回传ERP
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuInventoryReportResponse jingdongHufuInventoryReport(JingdongHufuInventoryReportRequest request) throws JdcloudSdkException {
        return new JingdongHufuInventoryReportExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符的接口,批量同步商品信息给WMS
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuItemsSynchronizeResponse jingdongHufuItemsSynchronize(JingdongHufuItemsSynchronizeRequest request) throws JdcloudSdkException {
        return new JingdongHufuItemsSynchronizeExecutor().client(this).execute(request);
    }

    
    /**
     * WMS调用接口，用于异步化的批量发货单创建结果通知。
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuDeliveryorderBatchcreateAnswerResponse jingdongHufuDeliveryorderBatchcreateAnswer(JingdongHufuDeliveryorderBatchcreateAnswerRequest request) throws JdcloudSdkException {
        return new JingdongHufuDeliveryorderBatchcreateAnswerExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符的接口,创建仓内加工单
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuStoreprocessCreateResponse jingdongHufuStoreprocessCreate(JingdongHufuStoreprocessCreateRequest request) throws JdcloudSdkException {
        return new JingdongHufuStoreprocessCreateExecutor().client(this).execute(request);
    }

    
    /**
     * WMS调用虎符的接口,回传仓内加工单创建情况
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuStoreprocessConfirmResponse jingdongHufuStoreprocessConfirm(JingdongHufuStoreprocessConfirmRequest request) throws JdcloudSdkException {
        return new JingdongHufuStoreprocessConfirmExecutor().client(this).execute(request);
    }

    
    /**
     * 调拨单查询
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuTransferorderQueryResponse jingdongHufuTransferorderQuery(JingdongHufuTransferorderQueryRequest request) throws JdcloudSdkException {
        return new JingdongHufuTransferorderQueryExecutor().client(this).execute(request);
    }

    
    /**
     * 调拨单创建
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuTransferorderCreateResponse jingdongHufuTransferorderCreate(JingdongHufuTransferorderCreateRequest request) throws JdcloudSdkException {
        return new JingdongHufuTransferorderCreateExecutor().client(this).execute(request);
    }

    
    /**
     * 调拨单通知
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuTransferorderReportResponse jingdongHufuTransferorderReport(JingdongHufuTransferorderReportRequest request) throws JdcloudSdkException {
        return new JingdongHufuTransferorderReportExecutor().client(this).execute(request);
    }

    
    /**
     * 商品查询接口
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuSingleitemQueryResponse jingdongHufuSingleitemQuery(JingdongHufuSingleitemQueryRequest request) throws JdcloudSdkException {
        return new JingdongHufuSingleitemQueryExecutor().client(this).execute(request);
    }

    
    /**
     * 店铺同步接口描述
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuShopSynchronizeResponse jingdongHufuShopSynchronize(JingdongHufuShopSynchronizeRequest request) throws JdcloudSdkException {
        return new JingdongHufuShopSynchronizeExecutor().client(this).execute(request);
    }

    
    /**
     * 仓库同步接口
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuWarehouseinfoSynchronizeResponse jingdongHufuWarehouseinfoSynchronize(JingdongHufuWarehouseinfoSynchronizeRequest request) throws JdcloudSdkException {
        return new JingdongHufuWarehouseinfoSynchronizeExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用接口，创建入库单;
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuEntryorderCreateResponse jingdongHufuEntryorderCreate(JingdongHufuEntryorderCreateRequest request) throws JdcloudSdkException {
        return new JingdongHufuEntryorderCreateExecutor().client(this).execute(request);
    }

    
    /**
     * 组合货品关系查询
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuCombineItemQueryResponse jingdongHufuCombineItemQuery(JingdongHufuCombineItemQueryRequest request) throws JdcloudSdkException {
        return new JingdongHufuCombineItemQueryExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用订单流水查询接口
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuOrderProcessQueryResponse jingdongHufuOrderProcessQuery(JingdongHufuOrderProcessQueryRequest request) throws JdcloudSdkException {
        return new JingdongHufuOrderProcessQueryExecutor().client(this).execute(request);
    }

    
    /**
     * 组合货品删除
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuCombineItemDeleteResponse jingdongHufuCombineItemDelete(JingdongHufuCombineItemDeleteRequest request) throws JdcloudSdkException {
        return new JingdongHufuCombineItemDeleteExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符的接口,将商品信息同步给WMS
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuCombineItemSynchronizeResponse jingdongHufuCombineItemSynchronize(JingdongHufuCombineItemSynchronizeRequest request) throws JdcloudSdkException {
        return new JingdongHufuCombineItemSynchronizeExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用虎符的接口,挂起某些创建的单据;场景介绍：ERP主动发起挂起（恢复）某些创建的单据，如入库单、出库单、退货单等
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuOrderPendingResponse jingdongHufuOrderPending(JingdongHufuOrderPendingRequest request) throws JdcloudSdkException {
        return new JingdongHufuOrderPendingExecutor().client(this).execute(request);
    }

    
    /**
     * ERP调用接口，将发货信息批量推送给WMS
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuDeliveryorderBatchcreateResponse jingdongHufuDeliveryorderBatchcreate(JingdongHufuDeliveryorderBatchcreateRequest request) throws JdcloudSdkException {
        return new JingdongHufuDeliveryorderBatchcreateExecutor().client(this).execute(request);
    }

    
    /**
     * WMS调用虎符的接口,将订单在仓库的状态回传给ERP；场景说明：仓库仓内操作状态回传给ERP, 比如打包操作完成时, 回传一个打 包完成的状态给到ERP, ERP自行决定如何处理。
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuOrderprocessReportResponse jingdongHufuOrderprocessReport(JingdongHufuOrderprocessReportRequest request) throws JdcloudSdkException {
        return new JingdongHufuOrderprocessReportExecutor().client(this).execute(request);
    }

    
    /**
     * 发货单确认接口
     *
     * @param request
     * @return
     * @throws JdcloudSdkException
     */
    public JingdongHufuDeliveryorderConfirmResponse jingdongHufuDeliveryorderConfirm(JingdongHufuDeliveryorderConfirmRequest request) throws JdcloudSdkException {
        return new JingdongHufuDeliveryorderConfirmExecutor().client(this).execute(request);
    }

    
}
