/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model;

import net.jdcloud.HufuStorage.model.jingdonghufuentryorderconfirm.*;
import com.jdcloud.sdk.apim.service.JdcloudRequest;
import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import net.jdcloud.HufuStorage.model.jingdonghufuentryorderconfirm.EntryOrderConfirmRequest;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * JingdongHufuEntryorderConfirmRequest
 */
@XmlRootElement(name = "jingdongHufuEntryorderConfirm_request")
@XmlAccessorType(XmlAccessType.FIELD)

public class JingdongHufuEntryorderConfirmRequest extends JdcloudRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "app_key")
    @SerializedName("app_key")
    @QueryParameter
    private String appKey = null;

    @XmlElement(name = "customerId")
    @SerializedName("customerId")
    @QueryParameter
    private String customerId = null;

    @XmlElement(name = "method")
    @SerializedName("method")
    @QueryParameter
    private String method = null;

    @XmlElement(name = "timestamp")
    @SerializedName("timestamp")
    @QueryParameter
    private String timestamp = null;

    @XmlElement(name = "format")
    @SerializedName("format")
    @QueryParameter
    private String format = null;

    @XmlElement(name = "v")
    @SerializedName("v")
    @QueryParameter
    private String v = null;

    @XmlElement(name = "sign_method")
    @SerializedName("sign_method")
    @QueryParameter
    private String signMethod = null;

    @XmlElement(name = "EntryOrderConfirmRequest")
    @SerializedName("EntryOrderConfirmRequest")
    @BodyParameter
    private EntryOrderConfirmRequest entryOrderConfirmRequest = null;

    public JingdongHufuEntryorderConfirmRequest appKey(String appKey) {
        this.appKey = appKey;
        return this;
    }

    /**
     * 应用接入时申请的appkey
     * @return appKey
    **/

    public String getAppKey() {
        return appKey;
    }

    public void setAppKey(String appKey) {
        this.appKey = appKey;
    }

    public JingdongHufuEntryorderConfirmRequest customerId(String customerId) {
        this.customerId = customerId;
        return this;
    }

    /**
     * wms应用为erp应用颁发的商家编号，每个erp对应多个商家，erp为哪个商家接入wms，使用customerId来区别
     * @return customerId
    **/

    public String getCustomerId() {
        return customerId;
    }

    public void setCustomerId(String customerId) {
        this.customerId = customerId;
    }

    public JingdongHufuEntryorderConfirmRequest method(String method) {
        this.method = method;
        return this;
    }

    /**
     * 前端相关的业务接口名称，如商品信息同步的请求，jingdong.hufu.deliveryorder.query
     * @return method
    **/

    public String getMethod() {
        return method;
    }

    public void setMethod(String method) {
        this.method = method;
    }

    public JingdongHufuEntryorderConfirmRequest timestamp(String timestamp) {
        this.timestamp = timestamp;
        return this;
    }

    /**
     * 时间戳，格式为yyyy-MM-dd HH:mm:ss
     * @return timestamp
    **/

    public String getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(String timestamp) {
        this.timestamp = timestamp;
    }

    public JingdongHufuEntryorderConfirmRequest format(String format) {
        this.format = format;
        return this;
    }

    /**
     * json
     * @return format
    **/

    public String getFormat() {
        return format;
    }

    public void setFormat(String format) {
        this.format = format;
    }

    public JingdongHufuEntryorderConfirmRequest v(String v) {
        this.v = v;
        return this;
    }

    /**
     * API协议版本，可选值：2.0
     * @return v
    **/

    public String getV() {
        return v;
    }

    public void setV(String v) {
        this.v = v;
    }

    public JingdongHufuEntryorderConfirmRequest signMethod(String signMethod) {
        this.signMethod = signMethod;
        return this;
    }

    /**
     * 表示使用哪个签名算法来加签，可选值为hmac-sha1和md5，默认为hmac-sha1，wms调用erp时将此参数设置为md5
     * @return signMethod
    **/

    public String getSignMethod() {
        return signMethod;
    }

    public void setSignMethod(String signMethod) {
        this.signMethod = signMethod;
    }

    public JingdongHufuEntryorderConfirmRequest entryOrderConfirmRequest(EntryOrderConfirmRequest entryOrderConfirmRequest) {
        this.entryOrderConfirmRequest = entryOrderConfirmRequest;
        return this;
    }

    /**
     * 
     * @return entryOrderConfirmRequest
    **/

    public EntryOrderConfirmRequest getEntryOrderConfirmRequest() {
        return entryOrderConfirmRequest;
    }

    public void setEntryOrderConfirmRequest(EntryOrderConfirmRequest entryOrderConfirmRequest) {
        this.entryOrderConfirmRequest = entryOrderConfirmRequest;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        JingdongHufuEntryorderConfirmRequest jingdongHufuEntryorderConfirmRequest = (JingdongHufuEntryorderConfirmRequest) o;
        return Objects.equals(this.appKey, jingdongHufuEntryorderConfirmRequest.appKey) &&
        Objects.equals(this.customerId, jingdongHufuEntryorderConfirmRequest.customerId) &&
        Objects.equals(this.method, jingdongHufuEntryorderConfirmRequest.method) &&
        Objects.equals(this.timestamp, jingdongHufuEntryorderConfirmRequest.timestamp) &&
        Objects.equals(this.format, jingdongHufuEntryorderConfirmRequest.format) &&
        Objects.equals(this.v, jingdongHufuEntryorderConfirmRequest.v) &&
        Objects.equals(this.signMethod, jingdongHufuEntryorderConfirmRequest.signMethod) &&
        Objects.equals(this.entryOrderConfirmRequest, jingdongHufuEntryorderConfirmRequest.entryOrderConfirmRequest);
    }

    @Override
    public int hashCode() {
        return Objects.hash(appKey, customerId, method, timestamp, format, v, signMethod, entryOrderConfirmRequest);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class JingdongHufuEntryorderConfirmRequest {\n");
        
        sb.append("    appKey: ").append(toIndentedString(appKey)).append("\n");
        sb.append("    customerId: ").append(toIndentedString(customerId)).append("\n");
        sb.append("    method: ").append(toIndentedString(method)).append("\n");
        sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
        sb.append("    format: ").append(toIndentedString(format)).append("\n");
        sb.append("    v: ").append(toIndentedString(v)).append("\n");
        sb.append("    signMethod: ").append(toIndentedString(signMethod)).append("\n");
        sb.append("    entryOrderConfirmRequest: ").append(toIndentedString(entryOrderConfirmRequest)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

