/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderbatchconfirm;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderbatchconfirm.Invoices;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 发货单信息
 */
@XmlRootElement(name = "deliveryOrder")
@XmlAccessorType(XmlAccessType.FIELD)

public class DeliveryOrder implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "orderType")
    @SerializedName("orderType")
    @Required
    private String orderType = null;

    @XmlElement(name = "storageFee")
    @SerializedName("storageFee")
    private String storageFee = null;

    @XmlElement(name = "operateTime")
    @SerializedName("operateTime")
    private String operateTime = null;

    @XmlElement(name = "orderConfirmTime")
    @SerializedName("orderConfirmTime")
    private String orderConfirmTime = null;

    @XmlElement(name = "deliveryOrderCode")
    @SerializedName("deliveryOrderCode")
    @Required
    private String deliveryOrderCode = null;

    @XmlElement(name = "operatorCode")
    @SerializedName("operatorCode")
    private String operatorCode = null;

    @XmlElement(name = "operatorName")
    @SerializedName("operatorName")
    private String operatorName = null;

    @XmlElement(name = "warehouseCode")
    @SerializedName("warehouseCode")
    @Required
    private String warehouseCode = null;

    @XmlElement(name = "outBizCode")
    @SerializedName("outBizCode")
    private String outBizCode = null;

    @XmlElementWrapper(name = "invoices")
    @XmlElement(name = "invoices")
    @SerializedName("invoices")
    private List<Invoices> invoices = null;

    @XmlElement(name = "confirmType")
    @SerializedName("confirmType")
    private Integer confirmType = null;

    @XmlElement(name = "deliveryOrderId")
    @SerializedName("deliveryOrderId")
    private String deliveryOrderId = null;

    @XmlElement(name = "status")
    @SerializedName("status")
    private String status = null;

    public DeliveryOrder orderType(String orderType) {
        this.orderType = orderType;
        return this;
    }

    /**
     * 出库单类型(JYCK&#x3D;一般交易出库;HHCK&#x3D;换货出库;BFCK&#x3D;补发出库;QTCK&#x3D;其他出库单)
     * @return orderType
    **/

    public String getOrderType() {
        return orderType;
    }

    public void setOrderType(String orderType) {
        this.orderType = orderType;
    }

    public DeliveryOrder storageFee(String storageFee) {
        this.storageFee = storageFee;
        return this;
    }

    /**
     * 仓储费用
     * @return storageFee
    **/

    public String getStorageFee() {
        return storageFee;
    }

    public void setStorageFee(String storageFee) {
        this.storageFee = storageFee;
    }

    public DeliveryOrder operateTime(String operateTime) {
        this.operateTime = operateTime;
        return this;
    }

    /**
     * 当前状态操作时间(YYYY-MM-DD HH:MM:SS)
     * @return operateTime
    **/

    public String getOperateTime() {
        return operateTime;
    }

    public void setOperateTime(String operateTime) {
        this.operateTime = operateTime;
    }

    public DeliveryOrder orderConfirmTime(String orderConfirmTime) {
        this.orderConfirmTime = orderConfirmTime;
        return this;
    }

    /**
     * 订单完成时间(YYYY-MM-DD HH:MM:SS)
     * @return orderConfirmTime
    **/

    public String getOrderConfirmTime() {
        return orderConfirmTime;
    }

    public void setOrderConfirmTime(String orderConfirmTime) {
        this.orderConfirmTime = orderConfirmTime;
    }

    public DeliveryOrder deliveryOrderCode(String deliveryOrderCode) {
        this.deliveryOrderCode = deliveryOrderCode;
        return this;
    }

    /**
     * 出库单号
     * @return deliveryOrderCode
    **/

    public String getDeliveryOrderCode() {
        return deliveryOrderCode;
    }

    public void setDeliveryOrderCode(String deliveryOrderCode) {
        this.deliveryOrderCode = deliveryOrderCode;
    }

    public DeliveryOrder operatorCode(String operatorCode) {
        this.operatorCode = operatorCode;
        return this;
    }

    /**
     * 当前状态操作员编码
     * @return operatorCode
    **/

    public String getOperatorCode() {
        return operatorCode;
    }

    public void setOperatorCode(String operatorCode) {
        this.operatorCode = operatorCode;
    }

    public DeliveryOrder operatorName(String operatorName) {
        this.operatorName = operatorName;
        return this;
    }

    /**
     * 当前状态操作员姓名
     * @return operatorName
    **/

    public String getOperatorName() {
        return operatorName;
    }

    public void setOperatorName(String operatorName) {
        this.operatorName = operatorName;
    }

    public DeliveryOrder warehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
        return this;
    }

    /**
     * 仓库编码
     * @return warehouseCode
    **/

    public String getWarehouseCode() {
        return warehouseCode;
    }

    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
    }

    public DeliveryOrder outBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
        return this;
    }

    /**
     * 外部业务编码(消息ID;用于去重;ISV对于同一请求;分配一个唯一性的编码。用来保证因为网络等原因导致重复传输;请求 不会被重复处理;条件必填;条件为一单需要多次确认时)
     * @return outBizCode
    **/

    public String getOutBizCode() {
        return outBizCode;
    }

    public void setOutBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
    }

    public DeliveryOrder invoices(List<Invoices> invoices) {
        this.invoices = invoices;
        return this;
    }

    public DeliveryOrder addInvoicesItem(Invoices invoicesItem) {
        if (this.invoices == null) {
            this.invoices = new ArrayList<Invoices>();
        }
        this.invoices.add(invoicesItem);
        return this;
    }

    /**
     * 发票信息
     * @return invoices
    **/

    public List<Invoices> getInvoices() {
        return invoices;
    }

    public void setInvoices(List<Invoices> invoices) {
        this.invoices = invoices;
    }

    public DeliveryOrder confirmType(Integer confirmType) {
        this.confirmType = confirmType;
        return this;
    }

    /**
     * 支持出库单多次发货(多次发货后确认时;0表示发货单最终状态确认;1表示发货单中间状态确认)
     * @return confirmType
    **/

    public Integer getConfirmType() {
        return confirmType;
    }

    public void setConfirmType(Integer confirmType) {
        this.confirmType = confirmType;
    }

    public DeliveryOrder deliveryOrderId(String deliveryOrderId) {
        this.deliveryOrderId = deliveryOrderId;
        return this;
    }

    /**
     * 仓储系统出库单号
     * @return deliveryOrderId
    **/

    public String getDeliveryOrderId() {
        return deliveryOrderId;
    }

    public void setDeliveryOrderId(String deliveryOrderId) {
        this.deliveryOrderId = deliveryOrderId;
    }

    public DeliveryOrder status(String status) {
        this.status = status;
        return this;
    }

    /**
     * 出库单状态(NEW-未开始处理;ACCEPT-仓库接单;PARTDELIVERED-部分发货完成;DELIVERED-发货完成;EXCEPTION-异 常;CANCELED-取消;CLOSED-关闭;REJECT-拒单;CANCELEDFAIL-取消失败;只传英文编码)
     * @return status
    **/

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        DeliveryOrder deliveryOrder = (DeliveryOrder) o;
        return Objects.equals(this.orderType, deliveryOrder.orderType) &&
        Objects.equals(this.storageFee, deliveryOrder.storageFee) &&
        Objects.equals(this.operateTime, deliveryOrder.operateTime) &&
        Objects.equals(this.orderConfirmTime, deliveryOrder.orderConfirmTime) &&
        Objects.equals(this.deliveryOrderCode, deliveryOrder.deliveryOrderCode) &&
        Objects.equals(this.operatorCode, deliveryOrder.operatorCode) &&
        Objects.equals(this.operatorName, deliveryOrder.operatorName) &&
        Objects.equals(this.warehouseCode, deliveryOrder.warehouseCode) &&
        Objects.equals(this.outBizCode, deliveryOrder.outBizCode) &&
        Objects.equals(this.invoices, deliveryOrder.invoices) &&
        Objects.equals(this.confirmType, deliveryOrder.confirmType) &&
        Objects.equals(this.deliveryOrderId, deliveryOrder.deliveryOrderId) &&
        Objects.equals(this.status, deliveryOrder.status);
    }

    @Override
    public int hashCode() {
        return Objects.hash(orderType, storageFee, operateTime, orderConfirmTime, deliveryOrderCode, operatorCode, operatorName, warehouseCode, outBizCode, invoices, confirmType, deliveryOrderId, status);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class DeliveryOrder {\n");
        
        sb.append("    orderType: ").append(toIndentedString(orderType)).append("\n");
        sb.append("    storageFee: ").append(toIndentedString(storageFee)).append("\n");
        sb.append("    operateTime: ").append(toIndentedString(operateTime)).append("\n");
        sb.append("    orderConfirmTime: ").append(toIndentedString(orderConfirmTime)).append("\n");
        sb.append("    deliveryOrderCode: ").append(toIndentedString(deliveryOrderCode)).append("\n");
        sb.append("    operatorCode: ").append(toIndentedString(operatorCode)).append("\n");
        sb.append("    operatorName: ").append(toIndentedString(operatorName)).append("\n");
        sb.append("    warehouseCode: ").append(toIndentedString(warehouseCode)).append("\n");
        sb.append("    outBizCode: ").append(toIndentedString(outBizCode)).append("\n");
        sb.append("    invoices: ").append(toIndentedString(invoices)).append("\n");
        sb.append("    confirmType: ").append(toIndentedString(confirmType)).append("\n");
        sb.append("    deliveryOrderId: ").append(toIndentedString(deliveryOrderId)).append("\n");
        sb.append("    status: ").append(toIndentedString(status)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

