/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderbatchcreate;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 单据列表
 */
@XmlRootElement(name = "orderLines")
@XmlAccessorType(XmlAccessType.FIELD)

public class OrderLines implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "orderLineNo")
    @SerializedName("orderLineNo")
    private String orderLineNo = null;

    @XmlElement(name = "inventoryType")
    @SerializedName("inventoryType")
    private String inventoryType = null;

    @XmlElement(name = "planQty")
    @SerializedName("planQty")
    @Required
    private Integer planQty = null;

    @XmlElement(name = "ownerCode")
    @SerializedName("ownerCode")
    @Required
    private String ownerCode = null;

    @XmlElement(name = "actualPrice")
    @SerializedName("actualPrice")
    @Required
    private String actualPrice = null;

    @XmlElement(name = "itemCode")
    @SerializedName("itemCode")
    @Required
    private String itemCode = null;

    @XmlElement(name = "batchCode")
    @SerializedName("batchCode")
    private String batchCode = null;

    @XmlElement(name = "discountAmount")
    @SerializedName("discountAmount")
    private String discountAmount = null;

    @XmlElement(name = "subSourceOrderCode")
    @SerializedName("subSourceOrderCode")
    private String subSourceOrderCode = null;

    @XmlElement(name = "productDate")
    @SerializedName("productDate")
    private String productDate = null;

    @XmlElement(name = "payNo")
    @SerializedName("payNo")
    private String payNo = null;

    @XmlElement(name = "itemId")
    @SerializedName("itemId")
    private String itemId = null;

    @XmlElement(name = "produceCode")
    @SerializedName("produceCode")
    private String produceCode = null;

    @XmlElement(name = "itemName")
    @SerializedName("itemName")
    private String itemName = null;

    @XmlElement(name = "extCode")
    @SerializedName("extCode")
    private String extCode = null;

    @XmlElement(name = "sourceOrderCode")
    @SerializedName("sourceOrderCode")
    private String sourceOrderCode = null;

    @XmlElement(name = "expireDate")
    @SerializedName("expireDate")
    private String expireDate = null;

    @XmlElement(name = "retailPrice")
    @SerializedName("retailPrice")
    private String retailPrice = null;

    public OrderLines orderLineNo(String orderLineNo) {
        this.orderLineNo = orderLineNo;
        return this;
    }

    /**
     * 单据行号
     * @return orderLineNo
    **/

    public String getOrderLineNo() {
        return orderLineNo;
    }

    public void setOrderLineNo(String orderLineNo) {
        this.orderLineNo = orderLineNo;
    }

    public OrderLines inventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
        return this;
    }

    /**
     * 库存类型(ZP&#x3D;正品;CC&#x3D;残次;JS&#x3D;机损;XS&#x3D; 箱损;ZT&#x3D;在途库存;默认为查所有类型的库存)
     * @return inventoryType
    **/

    public String getInventoryType() {
        return inventoryType;
    }

    public void setInventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
    }

    public OrderLines planQty(Integer planQty) {
        this.planQty = planQty;
        return this;
    }

    /**
     * 应发商品数量
     * @return planQty
    **/

    public Integer getPlanQty() {
        return planQty;
    }

    public void setPlanQty(Integer planQty) {
        this.planQty = planQty;
    }

    public OrderLines ownerCode(String ownerCode) {
        this.ownerCode = ownerCode;
        return this;
    }

    /**
     * 货主编码
     * @return ownerCode
    **/

    public String getOwnerCode() {
        return ownerCode;
    }

    public void setOwnerCode(String ownerCode) {
        this.ownerCode = ownerCode;
    }

    public OrderLines actualPrice(String actualPrice) {
        this.actualPrice = actualPrice;
        return this;
    }

    /**
     * 实际成交价
     * @return actualPrice
    **/

    public String getActualPrice() {
        return actualPrice;
    }

    public void setActualPrice(String actualPrice) {
        this.actualPrice = actualPrice;
    }

    public OrderLines itemCode(String itemCode) {
        this.itemCode = itemCode;
        return this;
    }

    /**
     * 商品编码
     * @return itemCode
    **/

    public String getItemCode() {
        return itemCode;
    }

    public void setItemCode(String itemCode) {
        this.itemCode = itemCode;
    }

    public OrderLines batchCode(String batchCode) {
        this.batchCode = batchCode;
        return this;
    }

    /**
     * 批次编码
     * @return batchCode
    **/

    public String getBatchCode() {
        return batchCode;
    }

    public void setBatchCode(String batchCode) {
        this.batchCode = batchCode;
    }

    public OrderLines discountAmount(String discountAmount) {
        this.discountAmount = discountAmount;
        return this;
    }

    /**
     * 单件商品折扣金额
     * @return discountAmount
    **/

    public String getDiscountAmount() {
        return discountAmount;
    }

    public void setDiscountAmount(String discountAmount) {
        this.discountAmount = discountAmount;
    }

    public OrderLines subSourceOrderCode(String subSourceOrderCode) {
        this.subSourceOrderCode = subSourceOrderCode;
        return this;
    }

    /**
     * 交易平台子订单编码
     * @return subSourceOrderCode
    **/

    public String getSubSourceOrderCode() {
        return subSourceOrderCode;
    }

    public void setSubSourceOrderCode(String subSourceOrderCode) {
        this.subSourceOrderCode = subSourceOrderCode;
    }

    public OrderLines productDate(String productDate) {
        this.productDate = productDate;
        return this;
    }

    /**
     * 生产日期(YYYY-MM-DD)
     * @return productDate
    **/

    public String getProductDate() {
        return productDate;
    }

    public void setProductDate(String productDate) {
        this.productDate = productDate;
    }

    public OrderLines payNo(String payNo) {
        this.payNo = payNo;
        return this;
    }

    /**
     * 支付平台交易号(淘系订单传支付宝交易号)
     * @return payNo
    **/

    public String getPayNo() {
        return payNo;
    }

    public void setPayNo(String payNo) {
        this.payNo = payNo;
    }

    public OrderLines itemId(String itemId) {
        this.itemId = itemId;
        return this;
    }

    /**
     * 仓储系统商品编码
     * @return itemId
    **/

    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    public OrderLines produceCode(String produceCode) {
        this.produceCode = produceCode;
        return this;
    }

    /**
     * 生产批号
     * @return produceCode
    **/

    public String getProduceCode() {
        return produceCode;
    }

    public void setProduceCode(String produceCode) {
        this.produceCode = produceCode;
    }

    public OrderLines itemName(String itemName) {
        this.itemName = itemName;
        return this;
    }

    /**
     * 商品名称
     * @return itemName
    **/

    public String getItemName() {
        return itemName;
    }

    public void setItemName(String itemName) {
        this.itemName = itemName;
    }

    public OrderLines extCode(String extCode) {
        this.extCode = extCode;
        return this;
    }

    /**
     * 交易平台商品编码
     * @return extCode
    **/

    public String getExtCode() {
        return extCode;
    }

    public void setExtCode(String extCode) {
        this.extCode = extCode;
    }

    public OrderLines sourceOrderCode(String sourceOrderCode) {
        this.sourceOrderCode = sourceOrderCode;
        return this;
    }

    /**
     * 交易平台订单
     * @return sourceOrderCode
    **/

    public String getSourceOrderCode() {
        return sourceOrderCode;
    }

    public void setSourceOrderCode(String sourceOrderCode) {
        this.sourceOrderCode = sourceOrderCode;
    }

    public OrderLines expireDate(String expireDate) {
        this.expireDate = expireDate;
        return this;
    }

    /**
     * 过期日期(YYYY-MM-DD)
     * @return expireDate
    **/

    public String getExpireDate() {
        return expireDate;
    }

    public void setExpireDate(String expireDate) {
        this.expireDate = expireDate;
    }

    public OrderLines retailPrice(String retailPrice) {
        this.retailPrice = retailPrice;
        return this;
    }

    /**
     * 零售价(零售价&#x3D;实际成交价+单件商品折扣金额)
     * @return retailPrice
    **/

    public String getRetailPrice() {
        return retailPrice;
    }

    public void setRetailPrice(String retailPrice) {
        this.retailPrice = retailPrice;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        OrderLines orderLines = (OrderLines) o;
        return Objects.equals(this.orderLineNo, orderLines.orderLineNo) &&
        Objects.equals(this.inventoryType, orderLines.inventoryType) &&
        Objects.equals(this.planQty, orderLines.planQty) &&
        Objects.equals(this.ownerCode, orderLines.ownerCode) &&
        Objects.equals(this.actualPrice, orderLines.actualPrice) &&
        Objects.equals(this.itemCode, orderLines.itemCode) &&
        Objects.equals(this.batchCode, orderLines.batchCode) &&
        Objects.equals(this.discountAmount, orderLines.discountAmount) &&
        Objects.equals(this.subSourceOrderCode, orderLines.subSourceOrderCode) &&
        Objects.equals(this.productDate, orderLines.productDate) &&
        Objects.equals(this.payNo, orderLines.payNo) &&
        Objects.equals(this.itemId, orderLines.itemId) &&
        Objects.equals(this.produceCode, orderLines.produceCode) &&
        Objects.equals(this.itemName, orderLines.itemName) &&
        Objects.equals(this.extCode, orderLines.extCode) &&
        Objects.equals(this.sourceOrderCode, orderLines.sourceOrderCode) &&
        Objects.equals(this.expireDate, orderLines.expireDate) &&
        Objects.equals(this.retailPrice, orderLines.retailPrice);
    }

    @Override
    public int hashCode() {
        return Objects.hash(orderLineNo, inventoryType, planQty, ownerCode, actualPrice, itemCode, batchCode, discountAmount, subSourceOrderCode, productDate, payNo, itemId, produceCode, itemName, extCode, sourceOrderCode, expireDate, retailPrice);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class OrderLines {\n");
        
        sb.append("    orderLineNo: ").append(toIndentedString(orderLineNo)).append("\n");
        sb.append("    inventoryType: ").append(toIndentedString(inventoryType)).append("\n");
        sb.append("    planQty: ").append(toIndentedString(planQty)).append("\n");
        sb.append("    ownerCode: ").append(toIndentedString(ownerCode)).append("\n");
        sb.append("    actualPrice: ").append(toIndentedString(actualPrice)).append("\n");
        sb.append("    itemCode: ").append(toIndentedString(itemCode)).append("\n");
        sb.append("    batchCode: ").append(toIndentedString(batchCode)).append("\n");
        sb.append("    discountAmount: ").append(toIndentedString(discountAmount)).append("\n");
        sb.append("    subSourceOrderCode: ").append(toIndentedString(subSourceOrderCode)).append("\n");
        sb.append("    productDate: ").append(toIndentedString(productDate)).append("\n");
        sb.append("    payNo: ").append(toIndentedString(payNo)).append("\n");
        sb.append("    itemId: ").append(toIndentedString(itemId)).append("\n");
        sb.append("    produceCode: ").append(toIndentedString(produceCode)).append("\n");
        sb.append("    itemName: ").append(toIndentedString(itemName)).append("\n");
        sb.append("    extCode: ").append(toIndentedString(extCode)).append("\n");
        sb.append("    sourceOrderCode: ").append(toIndentedString(sourceOrderCode)).append("\n");
        sb.append("    expireDate: ").append(toIndentedString(expireDate)).append("\n");
        sb.append("    retailPrice: ").append(toIndentedString(retailPrice)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

