/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderbatchcreateanswer;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderbatchcreateanswer.DeliveryOrders;
import net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderbatchcreateanswer.OrderInfo;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 发货单信息
 */
@XmlRootElement(name = "orders")
@XmlAccessorType(XmlAccessType.FIELD)

public class Orders implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElementWrapper(name = "deliveryOrders")
    @XmlElement(name = "deliveryOrders")
    @SerializedName("deliveryOrders")
    private List<DeliveryOrders> deliveryOrders = null;

    @XmlElement(name = "flag")
    @SerializedName("flag")
    private String flag = null;

    @XmlElement(name = "code")
    @SerializedName("code")
    private String code = null;

    @XmlElement(name = "orderInfo")
    @SerializedName("orderInfo")
    private OrderInfo orderInfo = null;

    @XmlElement(name = "deliveryOrderCode")
    @SerializedName("deliveryOrderCode")
    private String deliveryOrderCode = null;

    @XmlElement(name = "message")
    @SerializedName("message")
    private String message = null;

    public Orders deliveryOrders(List<DeliveryOrders> deliveryOrders) {
        this.deliveryOrders = deliveryOrders;
        return this;
    }

    public Orders addDeliveryOrdersItem(DeliveryOrders deliveryOrdersItem) {
        if (this.deliveryOrders == null) {
            this.deliveryOrders = new ArrayList<DeliveryOrders>();
        }
        this.deliveryOrders.add(deliveryOrdersItem);
        return this;
    }

    /**
     * 拆单情况
     * @return deliveryOrders
    **/

    public List<DeliveryOrders> getDeliveryOrders() {
        return deliveryOrders;
    }

    public void setDeliveryOrders(List<DeliveryOrders> deliveryOrders) {
        this.deliveryOrders = deliveryOrders;
    }

    public Orders flag(String flag) {
        this.flag = flag;
        return this;
    }

    /**
     * 响应结果:success|failure
     * @return flag
    **/

    public String getFlag() {
        return flag;
    }

    public void setFlag(String flag) {
        this.flag = flag;
    }

    public Orders code(String code) {
        this.code = code;
        return this;
    }

    /**
     * 响应码
     * @return code
    **/

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public Orders orderInfo(OrderInfo orderInfo) {
        this.orderInfo = orderInfo;
        return this;
    }

    /**
     * Get orderInfo
     * @return orderInfo
    **/

    public OrderInfo getOrderInfo() {
        return orderInfo;
    }

    public void setOrderInfo(OrderInfo orderInfo) {
        this.orderInfo = orderInfo;
    }

    public Orders deliveryOrderCode(String deliveryOrderCode) {
        this.deliveryOrderCode = deliveryOrderCode;
        return this;
    }

    /**
     * 发货单号
     * @return deliveryOrderCode
    **/

    public String getDeliveryOrderCode() {
        return deliveryOrderCode;
    }

    public void setDeliveryOrderCode(String deliveryOrderCode) {
        this.deliveryOrderCode = deliveryOrderCode;
    }

    public Orders message(String message) {
        this.message = message;
        return this;
    }

    /**
     * 响应信息
     * @return message
    **/

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Orders orders = (Orders) o;
        return Objects.equals(this.deliveryOrders, orders.deliveryOrders) &&
        Objects.equals(this.flag, orders.flag) &&
        Objects.equals(this.code, orders.code) &&
        Objects.equals(this.orderInfo, orders.orderInfo) &&
        Objects.equals(this.deliveryOrderCode, orders.deliveryOrderCode) &&
        Objects.equals(this.message, orders.message);
    }

    @Override
    public int hashCode() {
        return Objects.hash(deliveryOrders, flag, code, orderInfo, deliveryOrderCode, message);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Orders {\n");
        
        sb.append("    deliveryOrders: ").append(toIndentedString(deliveryOrders)).append("\n");
        sb.append("    flag: ").append(toIndentedString(flag)).append("\n");
        sb.append("    code: ").append(toIndentedString(code)).append("\n");
        sb.append("    orderInfo: ").append(toIndentedString(orderInfo)).append("\n");
        sb.append("    deliveryOrderCode: ").append(toIndentedString(deliveryOrderCode)).append("\n");
        sb.append("    message: ").append(toIndentedString(message)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

