/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderconfirm;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderconfirm.DeliveryOrder;
import net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderconfirm.OrderLines;
import net.jdcloud.HufuStorage.model.jingdonghufudeliveryorderconfirm.Packages;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * JingdongHufuDeliveryorderConfirmBody
 */
@XmlRootElement(name = "jingdong_hufu_deliveryorder_confirmBody")
@XmlAccessorType(XmlAccessType.FIELD)

public class JingdongHufuDeliveryorderConfirmBody implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElementWrapper(name = "orderLines")
    @XmlElement(name = "orderLines")
    @SerializedName("orderLines")
    private List<OrderLines> orderLines = null;

    @XmlElement(name = "inner")
    @SerializedName("extendProps")
    private Map<String, String> extendProps = null;

    @XmlElement(name = "deliveryOrder")
    @SerializedName("deliveryOrder")
    private DeliveryOrder deliveryOrder = null;

    @XmlElementWrapper(name = "packages")
    @XmlElement(name = "packages")
    @SerializedName("packages")
    private List<Packages> packages = null;

    public JingdongHufuDeliveryorderConfirmBody orderLines(List<OrderLines> orderLines) {
        this.orderLines = orderLines;
        return this;
    }

    public JingdongHufuDeliveryorderConfirmBody addOrderLinesItem(OrderLines orderLinesItem) {
        if (this.orderLines == null) {
            this.orderLines = new ArrayList<OrderLines>();
        }
        this.orderLines.add(orderLinesItem);
        return this;
    }

    /**
     * Get orderLines
     * @return orderLines
    **/

    public List<OrderLines> getOrderLines() {
        return orderLines;
    }

    public void setOrderLines(List<OrderLines> orderLines) {
        this.orderLines = orderLines;
    }

    public JingdongHufuDeliveryorderConfirmBody extendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
        return this;
    }

    public JingdongHufuDeliveryorderConfirmBody putExtendPropsItem(String key, String extendPropsItem) {
        if (this.extendProps == null) {
            this.extendProps = new HashMap<String, String>();
        }
        this.extendProps.put(key, extendPropsItem);
        return this;
    }

    /**
     * 扩展属性(map类型)
     * @return extendProps
    **/

    public Map<String, String> getExtendProps() {
        return extendProps;
    }

    public void setExtendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
    }

    public JingdongHufuDeliveryorderConfirmBody deliveryOrder(DeliveryOrder deliveryOrder) {
        this.deliveryOrder = deliveryOrder;
        return this;
    }

    /**
     * Get deliveryOrder
     * @return deliveryOrder
    **/

    public DeliveryOrder getDeliveryOrder() {
        return deliveryOrder;
    }

    public void setDeliveryOrder(DeliveryOrder deliveryOrder) {
        this.deliveryOrder = deliveryOrder;
    }

    public JingdongHufuDeliveryorderConfirmBody packages(List<Packages> packages) {
        this.packages = packages;
        return this;
    }

    public JingdongHufuDeliveryorderConfirmBody addPackagesItem(Packages packagesItem) {
        if (this.packages == null) {
            this.packages = new ArrayList<Packages>();
        }
        this.packages.add(packagesItem);
        return this;
    }

    /**
     * 包裹信息
     * @return packages
    **/

    public List<Packages> getPackages() {
        return packages;
    }

    public void setPackages(List<Packages> packages) {
        this.packages = packages;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        JingdongHufuDeliveryorderConfirmBody jingdongHufuDeliveryorderConfirmBody = (JingdongHufuDeliveryorderConfirmBody) o;
        return Objects.equals(this.orderLines, jingdongHufuDeliveryorderConfirmBody.orderLines) &&
        Objects.equals(this.extendProps, jingdongHufuDeliveryorderConfirmBody.extendProps) &&
        Objects.equals(this.deliveryOrder, jingdongHufuDeliveryorderConfirmBody.deliveryOrder) &&
        Objects.equals(this.packages, jingdongHufuDeliveryorderConfirmBody.packages);
    }

    @Override
    public int hashCode() {
        return Objects.hash(orderLines, extendProps, deliveryOrder, packages);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class JingdongHufuDeliveryorderConfirmBody {\n");
        
        sb.append("    orderLines: ").append(toIndentedString(orderLines)).append("\n");
        sb.append("    extendProps: ").append(toIndentedString(extendProps)).append("\n");
        sb.append("    deliveryOrder: ").append(toIndentedString(deliveryOrder)).append("\n");
        sb.append("    packages: ").append(toIndentedString(packages)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

