/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufuentryorderconfirm;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * Batchs
 */
@XmlRootElement(name = "batchs")
@XmlAccessorType(XmlAccessType.FIELD)

public class Batchs implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "produceCode")
    @SerializedName("produceCode")
    private String produceCode = null;

    @XmlElement(name = "inventoryType")
    @SerializedName("inventoryType")
    private String inventoryType = null;

    @XmlElement(name = "batchCode")
    @SerializedName("batchCode")
    private String batchCode = null;

    @XmlElement(name = "expireDate")
    @SerializedName("expireDate")
    private String expireDate = null;

    @XmlElement(name = "productDate")
    @SerializedName("productDate")
    private String productDate = null;

    @XmlElement(name = "actualQty")
    @SerializedName("actualQty")
    private String actualQty = null;

    public Batchs produceCode(String produceCode) {
        this.produceCode = produceCode;
        return this;
    }

    /**
     * 生产批号
     * @return produceCode
    **/

    public String getProduceCode() {
        return produceCode;
    }

    public void setProduceCode(String produceCode) {
        this.produceCode = produceCode;
    }

    public Batchs inventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
        return this;
    }

    /**
     * 库存类型(ZP&#x3D;正品;CC&#x3D;残次;JS&#x3D;机损;XS&#x3D;箱损;ZT&#x3D;在途库存;默认为查所有类型的库存)
     * @return inventoryType
    **/

    public String getInventoryType() {
        return inventoryType;
    }

    public void setInventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
    }

    public Batchs batchCode(String batchCode) {
        this.batchCode = batchCode;
        return this;
    }

    /**
     * 批次编号
     * @return batchCode
    **/

    public String getBatchCode() {
        return batchCode;
    }

    public void setBatchCode(String batchCode) {
        this.batchCode = batchCode;
    }

    public Batchs expireDate(String expireDate) {
        this.expireDate = expireDate;
        return this;
    }

    /**
     * 过期日期(YYYY-MM-DD)
     * @return expireDate
    **/

    public String getExpireDate() {
        return expireDate;
    }

    public void setExpireDate(String expireDate) {
        this.expireDate = expireDate;
    }

    public Batchs productDate(String productDate) {
        this.productDate = productDate;
        return this;
    }

    /**
     * 生产日期(YYYY-MM-DD)
     * @return productDate
    **/

    public String getProductDate() {
        return productDate;
    }

    public void setProductDate(String productDate) {
        this.productDate = productDate;
    }

    public Batchs actualQty(String actualQty) {
        this.actualQty = actualQty;
        return this;
    }

    /**
     * 实发数量(要求batchs节点下所有的实发数量之和等于orderline中的实发数量)
     * @return actualQty
    **/

    public String getActualQty() {
        return actualQty;
    }

    public void setActualQty(String actualQty) {
        this.actualQty = actualQty;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Batchs batchs = (Batchs) o;
        return Objects.equals(this.produceCode, batchs.produceCode) &&
        Objects.equals(this.inventoryType, batchs.inventoryType) &&
        Objects.equals(this.batchCode, batchs.batchCode) &&
        Objects.equals(this.expireDate, batchs.expireDate) &&
        Objects.equals(this.productDate, batchs.productDate) &&
        Objects.equals(this.actualQty, batchs.actualQty);
    }

    @Override
    public int hashCode() {
        return Objects.hash(produceCode, inventoryType, batchCode, expireDate, productDate, actualQty);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Batchs {\n");
        
        sb.append("    produceCode: ").append(toIndentedString(produceCode)).append("\n");
        sb.append("    inventoryType: ").append(toIndentedString(inventoryType)).append("\n");
        sb.append("    batchCode: ").append(toIndentedString(batchCode)).append("\n");
        sb.append("    expireDate: ").append(toIndentedString(expireDate)).append("\n");
        sb.append("    productDate: ").append(toIndentedString(productDate)).append("\n");
        sb.append("    actualQty: ").append(toIndentedString(actualQty)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

