/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufuentryordercreate;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 发件人信息
 */
@XmlRootElement(name = "senderInfo")
@XmlAccessorType(XmlAccessType.FIELD)

public class SenderInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "area")
    @SerializedName("area")
    private String area = null;

    @XmlElement(name = "zipCode")
    @SerializedName("zipCode")
    private String zipCode = null;

    @XmlElement(name = "province")
    @SerializedName("province")
    @Required
    private String province = null;

    @XmlElement(name = "town")
    @SerializedName("town")
    private String town = null;

    @XmlElement(name = "city")
    @SerializedName("city")
    @Required
    private String city = null;

    @XmlElement(name = "countryCode")
    @SerializedName("countryCode")
    private String countryCode = null;

    @XmlElement(name = "name")
    @SerializedName("name")
    @Required
    private String name = null;

    @XmlElement(name = "mobile")
    @SerializedName("mobile")
    @Required
    private String mobile = null;

    @XmlElement(name = "detailAddress")
    @SerializedName("detailAddress")
    @Required
    private String detailAddress = null;

    @XmlElement(name = "company")
    @SerializedName("company")
    private String company = null;

    @XmlElement(name = "tel")
    @SerializedName("tel")
    private String tel = null;

    @XmlElement(name = "email")
    @SerializedName("email")
    private String email = null;

    public SenderInfo area(String area) {
        this.area = area;
        return this;
    }

    /**
     * 区域
     * @return area
    **/

    public String getArea() {
        return area;
    }

    public void setArea(String area) {
        this.area = area;
    }

    public SenderInfo zipCode(String zipCode) {
        this.zipCode = zipCode;
        return this;
    }

    /**
     * 邮编
     * @return zipCode
    **/

    public String getZipCode() {
        return zipCode;
    }

    public void setZipCode(String zipCode) {
        this.zipCode = zipCode;
    }

    public SenderInfo province(String province) {
        this.province = province;
        return this;
    }

    /**
     * 省份
     * @return province
    **/

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public SenderInfo town(String town) {
        this.town = town;
        return this;
    }

    /**
     * 村镇
     * @return town
    **/

    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    public SenderInfo city(String city) {
        this.city = city;
        return this;
    }

    /**
     * 城市
     * @return city
    **/

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public SenderInfo countryCode(String countryCode) {
        this.countryCode = countryCode;
        return this;
    }

    /**
     * 国家二字码
     * @return countryCode
    **/

    public String getCountryCode() {
        return countryCode;
    }

    public void setCountryCode(String countryCode) {
        this.countryCode = countryCode;
    }

    public SenderInfo name(String name) {
        this.name = name;
        return this;
    }

    /**
     * 姓名
     * @return name
    **/

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public SenderInfo mobile(String mobile) {
        this.mobile = mobile;
        return this;
    }

    /**
     * 移动电话
     * @return mobile
    **/

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public SenderInfo detailAddress(String detailAddress) {
        this.detailAddress = detailAddress;
        return this;
    }

    /**
     * 详细地址
     * @return detailAddress
    **/

    public String getDetailAddress() {
        return detailAddress;
    }

    public void setDetailAddress(String detailAddress) {
        this.detailAddress = detailAddress;
    }

    public SenderInfo company(String company) {
        this.company = company;
        return this;
    }

    /**
     * 公司名称
     * @return company
    **/

    public String getCompany() {
        return company;
    }

    public void setCompany(String company) {
        this.company = company;
    }

    public SenderInfo tel(String tel) {
        this.tel = tel;
        return this;
    }

    /**
     * 固定电话
     * @return tel
    **/

    public String getTel() {
        return tel;
    }

    public void setTel(String tel) {
        this.tel = tel;
    }

    public SenderInfo email(String email) {
        this.email = email;
        return this;
    }

    /**
     * 电子邮箱
     * @return email
    **/

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        SenderInfo senderInfo = (SenderInfo) o;
        return Objects.equals(this.area, senderInfo.area) &&
        Objects.equals(this.zipCode, senderInfo.zipCode) &&
        Objects.equals(this.province, senderInfo.province) &&
        Objects.equals(this.town, senderInfo.town) &&
        Objects.equals(this.city, senderInfo.city) &&
        Objects.equals(this.countryCode, senderInfo.countryCode) &&
        Objects.equals(this.name, senderInfo.name) &&
        Objects.equals(this.mobile, senderInfo.mobile) &&
        Objects.equals(this.detailAddress, senderInfo.detailAddress) &&
        Objects.equals(this.company, senderInfo.company) &&
        Objects.equals(this.tel, senderInfo.tel) &&
        Objects.equals(this.email, senderInfo.email);
    }

    @Override
    public int hashCode() {
        return Objects.hash(area, zipCode, province, town, city, countryCode, name, mobile, detailAddress, company, tel, email);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class SenderInfo {\n");
        
        sb.append("    area: ").append(toIndentedString(area)).append("\n");
        sb.append("    zipCode: ").append(toIndentedString(zipCode)).append("\n");
        sb.append("    province: ").append(toIndentedString(province)).append("\n");
        sb.append("    town: ").append(toIndentedString(town)).append("\n");
        sb.append("    city: ").append(toIndentedString(city)).append("\n");
        sb.append("    countryCode: ").append(toIndentedString(countryCode)).append("\n");
        sb.append("    name: ").append(toIndentedString(name)).append("\n");
        sb.append("    mobile: ").append(toIndentedString(mobile)).append("\n");
        sb.append("    detailAddress: ").append(toIndentedString(detailAddress)).append("\n");
        sb.append("    company: ").append(toIndentedString(company)).append("\n");
        sb.append("    tel: ").append(toIndentedString(tel)).append("\n");
        sb.append("    email: ").append(toIndentedString(email)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

