/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufuentryorderquery;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * EntryOrderQueryRequest
 */
@XmlRootElement(name = "EntryOrderQueryRequest")
@XmlAccessorType(XmlAccessType.FIELD)

public class EntryOrderQueryRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "entryOrderCode")
    @SerializedName("entryOrderCode")
    @Required
    private String entryOrderCode = null;

    @XmlElement(name = "ownerCode")
    @SerializedName("ownerCode")
    private String ownerCode = null;

    @XmlElement(name = "entryOrderId")
    @SerializedName("entryOrderId")
    private String entryOrderId = null;

    @XmlElement(name = "pageSize")
    @SerializedName("pageSize")
    @Required
    private Integer pageSize = null;

    @XmlElement(name = "inner")
    @SerializedName("extendProps")
    private Map<String, String> extendProps = null;

    @XmlElement(name = "remark")
    @SerializedName("remark")
    private String remark = null;

    @XmlElement(name = "page")
    @SerializedName("page")
    @Required
    private Integer page = null;

    @XmlElement(name = "warehouseCode")
    @SerializedName("warehouseCode")
    private String warehouseCode = null;

    public EntryOrderQueryRequest entryOrderCode(String entryOrderCode) {
        this.entryOrderCode = entryOrderCode;
        return this;
    }

    /**
     * 入库单编码
     * @return entryOrderCode
    **/

    public String getEntryOrderCode() {
        return entryOrderCode;
    }

    public void setEntryOrderCode(String entryOrderCode) {
        this.entryOrderCode = entryOrderCode;
    }

    public EntryOrderQueryRequest ownerCode(String ownerCode) {
        this.ownerCode = ownerCode;
        return this;
    }

    /**
     * 货主编码
     * @return ownerCode
    **/

    public String getOwnerCode() {
        return ownerCode;
    }

    public void setOwnerCode(String ownerCode) {
        this.ownerCode = ownerCode;
    }

    public EntryOrderQueryRequest entryOrderId(String entryOrderId) {
        this.entryOrderId = entryOrderId;
        return this;
    }

    /**
     * 仓储系统入库单ID
     * @return entryOrderId
    **/

    public String getEntryOrderId() {
        return entryOrderId;
    }

    public void setEntryOrderId(String entryOrderId) {
        this.entryOrderId = entryOrderId;
    }

    public EntryOrderQueryRequest pageSize(Integer pageSize) {
        this.pageSize = pageSize;
        return this;
    }

    /**
     * 每页orderLine条数(最多100条)
     * @return pageSize
    **/

    public Integer getPageSize() {
        return pageSize;
    }

    public void setPageSize(Integer pageSize) {
        this.pageSize = pageSize;
    }

    public EntryOrderQueryRequest extendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
        return this;
    }

    public EntryOrderQueryRequest putExtendPropsItem(String key, String extendPropsItem) {
        if (this.extendProps == null) {
            this.extendProps = new HashMap<String, String>();
        }
        this.extendProps.put(key, extendPropsItem);
        return this;
    }

    /**
     * 扩展属性(map类型)
     * @return extendProps
    **/

    public Map<String, String> getExtendProps() {
        return extendProps;
    }

    public void setExtendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
    }

    public EntryOrderQueryRequest remark(String remark) {
        this.remark = remark;
        return this;
    }

    /**
     * 备注
     * @return remark
    **/

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public EntryOrderQueryRequest page(Integer page) {
        this.page = page;
        return this;
    }

    /**
     * 当前页(从1开始)
     * @return page
    **/

    public Integer getPage() {
        return page;
    }

    public void setPage(Integer page) {
        this.page = page;
    }

    public EntryOrderQueryRequest warehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
        return this;
    }

    /**
     * 仓库编码
     * @return warehouseCode
    **/

    public String getWarehouseCode() {
        return warehouseCode;
    }

    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        EntryOrderQueryRequest entryOrderQueryRequest = (EntryOrderQueryRequest) o;
        return Objects.equals(this.entryOrderCode, entryOrderQueryRequest.entryOrderCode) &&
        Objects.equals(this.ownerCode, entryOrderQueryRequest.ownerCode) &&
        Objects.equals(this.entryOrderId, entryOrderQueryRequest.entryOrderId) &&
        Objects.equals(this.pageSize, entryOrderQueryRequest.pageSize) &&
        Objects.equals(this.extendProps, entryOrderQueryRequest.extendProps) &&
        Objects.equals(this.remark, entryOrderQueryRequest.remark) &&
        Objects.equals(this.page, entryOrderQueryRequest.page) &&
        Objects.equals(this.warehouseCode, entryOrderQueryRequest.warehouseCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(entryOrderCode, ownerCode, entryOrderId, pageSize, extendProps, remark, page, warehouseCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class EntryOrderQueryRequest {\n");
        
        sb.append("    entryOrderCode: ").append(toIndentedString(entryOrderCode)).append("\n");
        sb.append("    ownerCode: ").append(toIndentedString(ownerCode)).append("\n");
        sb.append("    entryOrderId: ").append(toIndentedString(entryOrderId)).append("\n");
        sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
        sb.append("    extendProps: ").append(toIndentedString(extendProps)).append("\n");
        sb.append("    remark: ").append(toIndentedString(remark)).append("\n");
        sb.append("    page: ").append(toIndentedString(page)).append("\n");
        sb.append("    warehouseCode: ").append(toIndentedString(warehouseCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

