/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufuentryorderquery;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * OrderLines
 */
@XmlRootElement(name = "orderLines")
@XmlAccessorType(XmlAccessType.FIELD)

public class OrderLines implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "itemId")
    @SerializedName("itemId")
    private String itemId = null;

    @XmlElement(name = "produceCode")
    @SerializedName("produceCode")
    private String produceCode = null;

    @XmlElement(name = "orderLineNo")
    @SerializedName("orderLineNo")
    private String orderLineNo = null;

    @XmlElement(name = "itemName")
    @SerializedName("itemName")
    private String itemName = null;

    @XmlElement(name = "planQty")
    @SerializedName("planQty")
    private Integer planQty = null;

    @XmlElement(name = "inventoryType")
    @SerializedName("inventoryType")
    private String inventoryType = null;

    @XmlElement(name = "itemCode")
    @SerializedName("itemCode")
    private String itemCode = null;

    @XmlElement(name = "batchCode")
    @SerializedName("batchCode")
    private String batchCode = null;

    @XmlElement(name = "expireDate")
    @SerializedName("expireDate")
    private String expireDate = null;

    @XmlElement(name = "remark")
    @SerializedName("remark")
    private String remark = null;

    @XmlElement(name = "actualQty")
    @SerializedName("actualQty")
    private Integer actualQty = null;

    @XmlElement(name = "productDate")
    @SerializedName("productDate")
    private String productDate = null;

    public OrderLines itemId(String itemId) {
        this.itemId = itemId;
        return this;
    }

    /**
     * 仓储系统商品ID
     * @return itemId
    **/

    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    public OrderLines produceCode(String produceCode) {
        this.produceCode = produceCode;
        return this;
    }

    /**
     * 生产批号
     * @return produceCode
    **/

    public String getProduceCode() {
        return produceCode;
    }

    public void setProduceCode(String produceCode) {
        this.produceCode = produceCode;
    }

    public OrderLines orderLineNo(String orderLineNo) {
        this.orderLineNo = orderLineNo;
        return this;
    }

    /**
     * 入库单的行号
     * @return orderLineNo
    **/

    public String getOrderLineNo() {
        return orderLineNo;
    }

    public void setOrderLineNo(String orderLineNo) {
        this.orderLineNo = orderLineNo;
    }

    public OrderLines itemName(String itemName) {
        this.itemName = itemName;
        return this;
    }

    /**
     * 商品名称
     * @return itemName
    **/

    public String getItemName() {
        return itemName;
    }

    public void setItemName(String itemName) {
        this.itemName = itemName;
    }

    public OrderLines planQty(Integer planQty) {
        this.planQty = planQty;
        return this;
    }

    /**
     * 应收商品数量
     * @return planQty
    **/

    public Integer getPlanQty() {
        return planQty;
    }

    public void setPlanQty(Integer planQty) {
        this.planQty = planQty;
    }

    public OrderLines inventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
        return this;
    }

    /**
     * 库存类型(ZP&#x3D;正品;CC&#x3D;残次;JS&#x3D;机损;XS&#x3D;箱损;默认为ZP)
     * @return inventoryType
    **/

    public String getInventoryType() {
        return inventoryType;
    }

    public void setInventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
    }

    public OrderLines itemCode(String itemCode) {
        this.itemCode = itemCode;
        return this;
    }

    /**
     * 商品编码
     * @return itemCode
    **/

    public String getItemCode() {
        return itemCode;
    }

    public void setItemCode(String itemCode) {
        this.itemCode = itemCode;
    }

    public OrderLines batchCode(String batchCode) {
        this.batchCode = batchCode;
        return this;
    }

    /**
     * 批次编码
     * @return batchCode
    **/

    public String getBatchCode() {
        return batchCode;
    }

    public void setBatchCode(String batchCode) {
        this.batchCode = batchCode;
    }

    public OrderLines expireDate(String expireDate) {
        this.expireDate = expireDate;
        return this;
    }

    /**
     * 商品过期日期(YYYY-MM-DD)
     * @return expireDate
    **/

    public String getExpireDate() {
        return expireDate;
    }

    public void setExpireDate(String expireDate) {
        this.expireDate = expireDate;
    }

    public OrderLines remark(String remark) {
        this.remark = remark;
        return this;
    }

    /**
     * 备注
     * @return remark
    **/

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public OrderLines actualQty(Integer actualQty) {
        this.actualQty = actualQty;
        return this;
    }

    /**
     * 实收数量
     * @return actualQty
    **/

    public Integer getActualQty() {
        return actualQty;
    }

    public void setActualQty(Integer actualQty) {
        this.actualQty = actualQty;
    }

    public OrderLines productDate(String productDate) {
        this.productDate = productDate;
        return this;
    }

    /**
     * 商品生产日期(YYYY-MM-DD)
     * @return productDate
    **/

    public String getProductDate() {
        return productDate;
    }

    public void setProductDate(String productDate) {
        this.productDate = productDate;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        OrderLines orderLines = (OrderLines) o;
        return Objects.equals(this.itemId, orderLines.itemId) &&
        Objects.equals(this.produceCode, orderLines.produceCode) &&
        Objects.equals(this.orderLineNo, orderLines.orderLineNo) &&
        Objects.equals(this.itemName, orderLines.itemName) &&
        Objects.equals(this.planQty, orderLines.planQty) &&
        Objects.equals(this.inventoryType, orderLines.inventoryType) &&
        Objects.equals(this.itemCode, orderLines.itemCode) &&
        Objects.equals(this.batchCode, orderLines.batchCode) &&
        Objects.equals(this.expireDate, orderLines.expireDate) &&
        Objects.equals(this.remark, orderLines.remark) &&
        Objects.equals(this.actualQty, orderLines.actualQty) &&
        Objects.equals(this.productDate, orderLines.productDate);
    }

    @Override
    public int hashCode() {
        return Objects.hash(itemId, produceCode, orderLineNo, itemName, planQty, inventoryType, itemCode, batchCode, expireDate, remark, actualQty, productDate);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class OrderLines {\n");
        
        sb.append("    itemId: ").append(toIndentedString(itemId)).append("\n");
        sb.append("    produceCode: ").append(toIndentedString(produceCode)).append("\n");
        sb.append("    orderLineNo: ").append(toIndentedString(orderLineNo)).append("\n");
        sb.append("    itemName: ").append(toIndentedString(itemName)).append("\n");
        sb.append("    planQty: ").append(toIndentedString(planQty)).append("\n");
        sb.append("    inventoryType: ").append(toIndentedString(inventoryType)).append("\n");
        sb.append("    itemCode: ").append(toIndentedString(itemCode)).append("\n");
        sb.append("    batchCode: ").append(toIndentedString(batchCode)).append("\n");
        sb.append("    expireDate: ").append(toIndentedString(expireDate)).append("\n");
        sb.append("    remark: ").append(toIndentedString(remark)).append("\n");
        sb.append("    actualQty: ").append(toIndentedString(actualQty)).append("\n");
        sb.append("    productDate: ").append(toIndentedString(productDate)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

