/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufuinventoryreport;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.jdcloud.HufuStorage.model.jingdonghufuinventoryreport.InventoryItems;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * InventoryReportRequest
 */
@XmlRootElement(name = "InventoryReportRequest")
@XmlAccessorType(XmlAccessType.FIELD)

public class InventoryReportRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "ownerCode")
    @SerializedName("ownerCode")
    @Required
    private String ownerCode = null;

    @XmlElement(name = "adjustType")
    @SerializedName("adjustType")
    private String adjustType = null;

    @XmlElement(name = "totalPage")
    @SerializedName("totalPage")
    @Required
    private Integer totalPage = null;

    @XmlElement(name = "pageSize")
    @SerializedName("pageSize")
    @Required
    private Integer pageSize = null;

    @XmlElement(name = "remark")
    @SerializedName("remark")
    private String remark = null;

    @XmlElement(name = "warehouseCode")
    @SerializedName("warehouseCode")
    @Required
    private String warehouseCode = null;

    @XmlElement(name = "checkOrderId")
    @SerializedName("checkOrderId")
    private String checkOrderId = null;

    @XmlElement(name = "checkTime")
    @SerializedName("checkTime")
    private String checkTime = null;

    @XmlElement(name = "outBizCode")
    @SerializedName("outBizCode")
    @Required
    private String outBizCode = null;

    @XmlElementWrapper(name = "inventoryItems")
    @XmlElement(name = "inventoryItems")
    @SerializedName("inventoryItems")
    private List<InventoryItems> inventoryItems = null;

    @XmlElement(name = "inner")
    @SerializedName("extendProps")
    private Map<String, String> extendProps = null;

    @XmlElement(name = "currentPage")
    @SerializedName("currentPage")
    @Required
    private Integer currentPage = null;

    @XmlElement(name = "checkOrderCode")
    @SerializedName("checkOrderCode")
    @Required
    private String checkOrderCode = null;

    public InventoryReportRequest ownerCode(String ownerCode) {
        this.ownerCode = ownerCode;
        return this;
    }

    /**
     * 货主编码
     * @return ownerCode
    **/

    public String getOwnerCode() {
        return ownerCode;
    }

    public void setOwnerCode(String ownerCode) {
        this.ownerCode = ownerCode;
    }

    public InventoryReportRequest adjustType(String adjustType) {
        this.adjustType = adjustType;
        return this;
    }

    /**
     * 变动类型：CHECK&#x3D;盘点 ADJUST&#x3D;调整
     * @return adjustType
    **/

    public String getAdjustType() {
        return adjustType;
    }

    public void setAdjustType(String adjustType) {
        this.adjustType = adjustType;
    }

    public InventoryReportRequest totalPage(Integer totalPage) {
        this.totalPage = totalPage;
        return this;
    }

    /**
     * 总页数
     * @return totalPage
    **/

    public Integer getTotalPage() {
        return totalPage;
    }

    public void setTotalPage(Integer totalPage) {
        this.totalPage = totalPage;
    }

    public InventoryReportRequest pageSize(Integer pageSize) {
        this.pageSize = pageSize;
        return this;
    }

    /**
     * 每页记录的条数
     * @return pageSize
    **/

    public Integer getPageSize() {
        return pageSize;
    }

    public void setPageSize(Integer pageSize) {
        this.pageSize = pageSize;
    }

    public InventoryReportRequest remark(String remark) {
        this.remark = remark;
        return this;
    }

    /**
     * 备注
     * @return remark
    **/

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public InventoryReportRequest warehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
        return this;
    }

    /**
     * 仓库编码
     * @return warehouseCode
    **/

    public String getWarehouseCode() {
        return warehouseCode;
    }

    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
    }

    public InventoryReportRequest checkOrderId(String checkOrderId) {
        this.checkOrderId = checkOrderId;
        return this;
    }

    /**
     * 仓储系统的盘点单编码
     * @return checkOrderId
    **/

    public String getCheckOrderId() {
        return checkOrderId;
    }

    public void setCheckOrderId(String checkOrderId) {
        this.checkOrderId = checkOrderId;
    }

    public InventoryReportRequest checkTime(String checkTime) {
        this.checkTime = checkTime;
        return this;
    }

    /**
     * 盘点时间(YYYY-MM-DD HH:MM:SS)
     * @return checkTime
    **/

    public String getCheckTime() {
        return checkTime;
    }

    public void setCheckTime(String checkTime) {
        this.checkTime = checkTime;
    }

    public InventoryReportRequest outBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
        return this;
    }

    /**
     * 外部业务编码(消息ID;用于去重;ISV对于同一请求;分配一个唯一性的编码。用来保证因为网络等原因导致重复传输;请求不 会被重复处理)
     * @return outBizCode
    **/

    public String getOutBizCode() {
        return outBizCode;
    }

    public void setOutBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
    }

    public InventoryReportRequest inventoryItems(List<InventoryItems> inventoryItems) {
        this.inventoryItems = inventoryItems;
        return this;
    }

    public InventoryReportRequest addInventoryItemsItem(InventoryItems inventoryItemsItem) {
        if (this.inventoryItems == null) {
            this.inventoryItems = new ArrayList<InventoryItems>();
        }
        this.inventoryItems.add(inventoryItemsItem);
        return this;
    }

    /**
     * 商品库存信息列表
     * @return inventoryItems
    **/

    public List<InventoryItems> getInventoryItems() {
        return inventoryItems;
    }

    public void setInventoryItems(List<InventoryItems> inventoryItems) {
        this.inventoryItems = inventoryItems;
    }

    public InventoryReportRequest extendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
        return this;
    }

    public InventoryReportRequest putExtendPropsItem(String key, String extendPropsItem) {
        if (this.extendProps == null) {
            this.extendProps = new HashMap<String, String>();
        }
        this.extendProps.put(key, extendPropsItem);
        return this;
    }

    /**
     * 扩展属性(map类型)
     * @return extendProps
    **/

    public Map<String, String> getExtendProps() {
        return extendProps;
    }

    public void setExtendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
    }

    public InventoryReportRequest currentPage(Integer currentPage) {
        this.currentPage = currentPage;
        return this;
    }

    /**
     * 当前页(从1开始)
     * @return currentPage
    **/

    public Integer getCurrentPage() {
        return currentPage;
    }

    public void setCurrentPage(Integer currentPage) {
        this.currentPage = currentPage;
    }

    public InventoryReportRequest checkOrderCode(String checkOrderCode) {
        this.checkOrderCode = checkOrderCode;
        return this;
    }

    /**
     * 盘点单编码
     * @return checkOrderCode
    **/

    public String getCheckOrderCode() {
        return checkOrderCode;
    }

    public void setCheckOrderCode(String checkOrderCode) {
        this.checkOrderCode = checkOrderCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        InventoryReportRequest inventoryReportRequest = (InventoryReportRequest) o;
        return Objects.equals(this.ownerCode, inventoryReportRequest.ownerCode) &&
        Objects.equals(this.adjustType, inventoryReportRequest.adjustType) &&
        Objects.equals(this.totalPage, inventoryReportRequest.totalPage) &&
        Objects.equals(this.pageSize, inventoryReportRequest.pageSize) &&
        Objects.equals(this.remark, inventoryReportRequest.remark) &&
        Objects.equals(this.warehouseCode, inventoryReportRequest.warehouseCode) &&
        Objects.equals(this.checkOrderId, inventoryReportRequest.checkOrderId) &&
        Objects.equals(this.checkTime, inventoryReportRequest.checkTime) &&
        Objects.equals(this.outBizCode, inventoryReportRequest.outBizCode) &&
        Objects.equals(this.inventoryItems, inventoryReportRequest.inventoryItems) &&
        Objects.equals(this.extendProps, inventoryReportRequest.extendProps) &&
        Objects.equals(this.currentPage, inventoryReportRequest.currentPage) &&
        Objects.equals(this.checkOrderCode, inventoryReportRequest.checkOrderCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(ownerCode, adjustType, totalPage, pageSize, remark, warehouseCode, checkOrderId, checkTime, outBizCode, inventoryItems, extendProps, currentPage, checkOrderCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class InventoryReportRequest {\n");
        
        sb.append("    ownerCode: ").append(toIndentedString(ownerCode)).append("\n");
        sb.append("    adjustType: ").append(toIndentedString(adjustType)).append("\n");
        sb.append("    totalPage: ").append(toIndentedString(totalPage)).append("\n");
        sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
        sb.append("    remark: ").append(toIndentedString(remark)).append("\n");
        sb.append("    warehouseCode: ").append(toIndentedString(warehouseCode)).append("\n");
        sb.append("    checkOrderId: ").append(toIndentedString(checkOrderId)).append("\n");
        sb.append("    checkTime: ").append(toIndentedString(checkTime)).append("\n");
        sb.append("    outBizCode: ").append(toIndentedString(outBizCode)).append("\n");
        sb.append("    inventoryItems: ").append(toIndentedString(inventoryItems)).append("\n");
        sb.append("    extendProps: ").append(toIndentedString(extendProps)).append("\n");
        sb.append("    currentPage: ").append(toIndentedString(currentPage)).append("\n");
        sb.append("    checkOrderCode: ").append(toIndentedString(checkOrderCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

