/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufuitemssynchronize;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.jdcloud.HufuStorage.model.jingdonghufuitemssynchronize.ProductItems;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * ItemsSynchronizeRequest
 */
@XmlRootElement(name = "ItemsSynchronizeRequest")
@XmlAccessorType(XmlAccessType.FIELD)

public class ItemsSynchronizeRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "actionType")
    @SerializedName("actionType")
    @Required
    private String actionType = null;

    @XmlElementWrapper(name = "productItems")
    @XmlElement(name = "productItems")
    @SerializedName("productItems")
    private List<ProductItems> productItems = null;

    @XmlElement(name = "ownerCode")
    @SerializedName("ownerCode")
    @Required
    private String ownerCode = null;

    @XmlElement(name = "inner")
    @SerializedName("extendProps")
    private Map<String, String> extendProps = null;

    @XmlElement(name = "warehouseCode")
    @SerializedName("warehouseCode")
    @Required
    private String warehouseCode = null;

    public ItemsSynchronizeRequest actionType(String actionType) {
        this.actionType = actionType;
        return this;
    }

    /**
     * 操作类型(两种类型：add|update)
     * @return actionType
    **/

    public String getActionType() {
        return actionType;
    }

    public void setActionType(String actionType) {
        this.actionType = actionType;
    }

    public ItemsSynchronizeRequest productItems(List<ProductItems> productItems) {
        this.productItems = productItems;
        return this;
    }

    public ItemsSynchronizeRequest addProductItemsItem(ProductItems productItemsItem) {
        if (this.productItems == null) {
            this.productItems = new ArrayList<ProductItems>();
        }
        this.productItems.add(productItemsItem);
        return this;
    }

    /**
     * 同步的商品信息
     * @return productItems
    **/

    public List<ProductItems> getProductItems() {
        return productItems;
    }

    public void setProductItems(List<ProductItems> productItems) {
        this.productItems = productItems;
    }

    public ItemsSynchronizeRequest ownerCode(String ownerCode) {
        this.ownerCode = ownerCode;
        return this;
    }

    /**
     * 货主编码
     * @return ownerCode
    **/

    public String getOwnerCode() {
        return ownerCode;
    }

    public void setOwnerCode(String ownerCode) {
        this.ownerCode = ownerCode;
    }

    public ItemsSynchronizeRequest extendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
        return this;
    }

    public ItemsSynchronizeRequest putExtendPropsItem(String key, String extendPropsItem) {
        if (this.extendProps == null) {
            this.extendProps = new HashMap<String, String>();
        }
        this.extendProps.put(key, extendPropsItem);
        return this;
    }

    /**
     * 扩展属性(map类型)
     * @return extendProps
    **/

    public Map<String, String> getExtendProps() {
        return extendProps;
    }

    public void setExtendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
    }

    public ItemsSynchronizeRequest warehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
        return this;
    }

    /**
     * 仓库编码(统仓统配等无需ERP指定仓储编码的情况填OTHER)
     * @return warehouseCode
    **/

    public String getWarehouseCode() {
        return warehouseCode;
    }

    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ItemsSynchronizeRequest itemsSynchronizeRequest = (ItemsSynchronizeRequest) o;
        return Objects.equals(this.actionType, itemsSynchronizeRequest.actionType) &&
        Objects.equals(this.productItems, itemsSynchronizeRequest.productItems) &&
        Objects.equals(this.ownerCode, itemsSynchronizeRequest.ownerCode) &&
        Objects.equals(this.extendProps, itemsSynchronizeRequest.extendProps) &&
        Objects.equals(this.warehouseCode, itemsSynchronizeRequest.warehouseCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(actionType, productItems, ownerCode, extendProps, warehouseCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ItemsSynchronizeRequest {\n");
        
        sb.append("    actionType: ").append(toIndentedString(actionType)).append("\n");
        sb.append("    productItems: ").append(toIndentedString(productItems)).append("\n");
        sb.append("    ownerCode: ").append(toIndentedString(ownerCode)).append("\n");
        sb.append("    extendProps: ").append(toIndentedString(extendProps)).append("\n");
        sb.append("    warehouseCode: ").append(toIndentedString(warehouseCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

