/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufuorderprocessquery;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 处理流程
 */
@XmlRootElement(name = "processes")
@XmlAccessorType(XmlAccessType.FIELD)

public class Processes implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "operateInfo")
    @SerializedName("operateInfo")
    private String operateInfo = null;

    @XmlElement(name = "processStatus")
    @SerializedName("processStatus")
    private String processStatus = null;

    @XmlElement(name = "operateTime")
    @SerializedName("operateTime")
    private String operateTime = null;

    @XmlElement(name = "remark")
    @SerializedName("remark")
    private String remark = null;

    @XmlElement(name = "operatorCode")
    @SerializedName("operatorCode")
    private String operatorCode = null;

    @XmlElement(name = "operatorName")
    @SerializedName("operatorName")
    private String operatorName = null;

    public Processes operateInfo(String operateInfo) {
        this.operateInfo = operateInfo;
        return this;
    }

    /**
     * 操作内容
     * @return operateInfo
    **/

    public String getOperateInfo() {
        return operateInfo;
    }

    public void setOperateInfo(String operateInfo) {
        this.operateInfo = operateInfo;
    }

    public Processes processStatus(String processStatus) {
        this.processStatus = processStatus;
        return this;
    }

    /**
     * 单据状态(NEW&#x3D;新增;ACCEPT&#x3D;仓库接单;PRINT&#x3D;打印;PICK&#x3D;捡货;CHECK&#x3D;复核;PACKAGE&#x3D;打包;WEIGH&#x3D;称重;READY&#x3D;待提货;DELIVERED&#x3D;已发货;EXCEPTION&#x3D;异常;CLOSED&#x3D;关闭;CANCELED&#x3D;取消;REJECT&#x3D;仓库拒单;REFUSE&#x3D;客户拒签;CANCELEDFAIL&#x3D;取消失败;SIGN&#x3D;签收;TMSCANCELED&#x3D;快递拦截;PARTFULFILLED&#x3D;部分收货完成;FULFILLED&#x3D;收货完成;PARTDELIVERED&#x3D;部分发货完成;OTHER&#x3D;其他;只传英文编码)
     * @return processStatus
    **/

    public String getProcessStatus() {
        return processStatus;
    }

    public void setProcessStatus(String processStatus) {
        this.processStatus = processStatus;
    }

    public Processes operateTime(String operateTime) {
        this.operateTime = operateTime;
        return this;
    }

    /**
     * 该状态操作时间(YYYY-MM-DD HH:MM:SS)
     * @return operateTime
    **/

    public String getOperateTime() {
        return operateTime;
    }

    public void setOperateTime(String operateTime) {
        this.operateTime = operateTime;
    }

    public Processes remark(String remark) {
        this.remark = remark;
        return this;
    }

    /**
     * 备注
     * @return remark
    **/

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Processes operatorCode(String operatorCode) {
        this.operatorCode = operatorCode;
        return this;
    }

    /**
     * 该状态操作员编码
     * @return operatorCode
    **/

    public String getOperatorCode() {
        return operatorCode;
    }

    public void setOperatorCode(String operatorCode) {
        this.operatorCode = operatorCode;
    }

    public Processes operatorName(String operatorName) {
        this.operatorName = operatorName;
        return this;
    }

    /**
     * 该状态操作员姓名
     * @return operatorName
    **/

    public String getOperatorName() {
        return operatorName;
    }

    public void setOperatorName(String operatorName) {
        this.operatorName = operatorName;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Processes processes = (Processes) o;
        return Objects.equals(this.operateInfo, processes.operateInfo) &&
        Objects.equals(this.processStatus, processes.processStatus) &&
        Objects.equals(this.operateTime, processes.operateTime) &&
        Objects.equals(this.remark, processes.remark) &&
        Objects.equals(this.operatorCode, processes.operatorCode) &&
        Objects.equals(this.operatorName, processes.operatorName);
    }

    @Override
    public int hashCode() {
        return Objects.hash(operateInfo, processStatus, operateTime, remark, operatorCode, operatorName);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Processes {\n");
        
        sb.append("    operateInfo: ").append(toIndentedString(operateInfo)).append("\n");
        sb.append("    processStatus: ").append(toIndentedString(processStatus)).append("\n");
        sb.append("    operateTime: ").append(toIndentedString(operateTime)).append("\n");
        sb.append("    remark: ").append(toIndentedString(remark)).append("\n");
        sb.append("    operatorCode: ").append(toIndentedString(operatorCode)).append("\n");
        sb.append("    operatorName: ").append(toIndentedString(operatorName)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

