/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufureturnordercreate;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import net.jdcloud.HufuStorage.model.jingdonghufureturnordercreate.SenderInfo;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 退货单信息
 */
@XmlRootElement(name = "returnOrder")
@XmlAccessorType(XmlAccessType.FIELD)

public class ReturnOrder implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "sellerNick")
    @SerializedName("sellerNick")
    private String sellerNick = null;

    @XmlElement(name = "orderType")
    @SerializedName("orderType")
    private String orderType = null;

    @XmlElement(name = "buyerNick")
    @SerializedName("buyerNick")
    private String buyerNick = null;

    @XmlElement(name = "preDeliveryOrderCode")
    @SerializedName("preDeliveryOrderCode")
    @Required
    private String preDeliveryOrderCode = null;

    @XmlElement(name = "logisticsCode")
    @SerializedName("logisticsCode")
    @Required
    private String logisticsCode = null;

    @XmlElement(name = "remark")
    @SerializedName("remark")
    private String remark = null;

    @XmlElement(name = "sourcePlatformName")
    @SerializedName("sourcePlatformName")
    private String sourcePlatformName = null;

    @XmlElement(name = "warehouseCode")
    @SerializedName("warehouseCode")
    @Required
    private String warehouseCode = null;

    @XmlElement(name = "logisticsName")
    @SerializedName("logisticsName")
    private String logisticsName = null;

    @XmlElement(name = "shopNick")
    @SerializedName("shopNick")
    private String shopNick = null;

    @XmlElement(name = "preDeliveryOrderId")
    @SerializedName("preDeliveryOrderId")
    private String preDeliveryOrderId = null;

    @XmlElement(name = "senderInfo")
    @SerializedName("senderInfo")
    private SenderInfo senderInfo = null;

    @XmlElement(name = "returnOrderCode")
    @SerializedName("returnOrderCode")
    @Required
    private String returnOrderCode = null;

    @XmlElement(name = "sourcePlatformCode")
    @SerializedName("sourcePlatformCode")
    private String sourcePlatformCode = null;

    @XmlElement(name = "returnReason")
    @SerializedName("returnReason")
    private String returnReason = null;

    @XmlElement(name = "orderFlag")
    @SerializedName("orderFlag")
    private String orderFlag = null;

    @XmlElement(name = "expressCode")
    @SerializedName("expressCode")
    private String expressCode = null;

    public ReturnOrder sellerNick(String sellerNick) {
        this.sellerNick = sellerNick;
        return this;
    }

    /**
     * 卖家名称
     * @return sellerNick
    **/

    public String getSellerNick() {
        return sellerNick;
    }

    public void setSellerNick(String sellerNick) {
        this.sellerNick = sellerNick;
    }

    public ReturnOrder orderType(String orderType) {
        this.orderType = orderType;
        return this;
    }

    /**
     * 单据类型(THRK&#x3D;退货入库;HHRK&#x3D;换货入库;只传英文编码)
     * @return orderType
    **/

    public String getOrderType() {
        return orderType;
    }

    public void setOrderType(String orderType) {
        this.orderType = orderType;
    }

    public ReturnOrder buyerNick(String buyerNick) {
        this.buyerNick = buyerNick;
        return this;
    }

    /**
     * 买家昵称
     * @return buyerNick
    **/

    public String getBuyerNick() {
        return buyerNick;
    }

    public void setBuyerNick(String buyerNick) {
        this.buyerNick = buyerNick;
    }

    public ReturnOrder preDeliveryOrderCode(String preDeliveryOrderCode) {
        this.preDeliveryOrderCode = preDeliveryOrderCode;
        return this;
    }

    /**
     * 原出库单号(ERP分配)
     * @return preDeliveryOrderCode
    **/

    public String getPreDeliveryOrderCode() {
        return preDeliveryOrderCode;
    }

    public void setPreDeliveryOrderCode(String preDeliveryOrderCode) {
        this.preDeliveryOrderCode = preDeliveryOrderCode;
    }

    public ReturnOrder logisticsCode(String logisticsCode) {
        this.logisticsCode = logisticsCode;
        return this;
    }

    /**
     * 物流公司编码(SF&#x3D;顺丰、EMS&#x3D;标准快递、EYB&#x3D;经济快件、ZJS&#x3D;宅急送、YTO&#x3D;圆通、ZTO&#x3D;中通(ZTO)、HTKY&#x3D;百世汇通、 UC&#x3D;优速、STO&#x3D;申通、TTKDEX&#x3D;天天快递、QFKD&#x3D;全峰、FAST&#x3D;快捷、POSTB&#x3D;邮政小包、GTO&#x3D;国通、YUNDA&#x3D;韵达、JD&#x3D;京东配送、DD&#x3D;当当宅配、 AMAZON&#x3D;亚马逊物流、OTHER&#x3D;其他;只传英文编码)
     * @return logisticsCode
    **/

    public String getLogisticsCode() {
        return logisticsCode;
    }

    public void setLogisticsCode(String logisticsCode) {
        this.logisticsCode = logisticsCode;
    }

    public ReturnOrder remark(String remark) {
        this.remark = remark;
        return this;
    }

    /**
     * 备注
     * @return remark
    **/

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public ReturnOrder sourcePlatformName(String sourcePlatformName) {
        this.sourcePlatformName = sourcePlatformName;
        return this;
    }

    /**
     * 订单来源平台名称
     * @return sourcePlatformName
    **/

    public String getSourcePlatformName() {
        return sourcePlatformName;
    }

    public void setSourcePlatformName(String sourcePlatformName) {
        this.sourcePlatformName = sourcePlatformName;
    }

    public ReturnOrder warehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
        return this;
    }

    /**
     * 仓库编码(统仓统配等无需ERP指定仓储编码的情况填OTHER)
     * @return warehouseCode
    **/

    public String getWarehouseCode() {
        return warehouseCode;
    }

    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
    }

    public ReturnOrder logisticsName(String logisticsName) {
        this.logisticsName = logisticsName;
        return this;
    }

    /**
     * 物流公司名称
     * @return logisticsName
    **/

    public String getLogisticsName() {
        return logisticsName;
    }

    public void setLogisticsName(String logisticsName) {
        this.logisticsName = logisticsName;
    }

    public ReturnOrder shopNick(String shopNick) {
        this.shopNick = shopNick;
        return this;
    }

    /**
     * 店铺名称
     * @return shopNick
    **/

    public String getShopNick() {
        return shopNick;
    }

    public void setShopNick(String shopNick) {
        this.shopNick = shopNick;
    }

    public ReturnOrder preDeliveryOrderId(String preDeliveryOrderId) {
        this.preDeliveryOrderId = preDeliveryOrderId;
        return this;
    }

    /**
     * 原出库单号(WMS分配)
     * @return preDeliveryOrderId
    **/

    public String getPreDeliveryOrderId() {
        return preDeliveryOrderId;
    }

    public void setPreDeliveryOrderId(String preDeliveryOrderId) {
        this.preDeliveryOrderId = preDeliveryOrderId;
    }

    public ReturnOrder senderInfo(SenderInfo senderInfo) {
        this.senderInfo = senderInfo;
        return this;
    }

    /**
     * Get senderInfo
     * @return senderInfo
    **/

    public SenderInfo getSenderInfo() {
        return senderInfo;
    }

    public void setSenderInfo(SenderInfo senderInfo) {
        this.senderInfo = senderInfo;
    }

    public ReturnOrder returnOrderCode(String returnOrderCode) {
        this.returnOrderCode = returnOrderCode;
        return this;
    }

    /**
     * ERP的退货入库单编码
     * @return returnOrderCode
    **/

    public String getReturnOrderCode() {
        return returnOrderCode;
    }

    public void setReturnOrderCode(String returnOrderCode) {
        this.returnOrderCode = returnOrderCode;
    }

    public ReturnOrder sourcePlatformCode(String sourcePlatformCode) {
        this.sourcePlatformCode = sourcePlatformCode;
        return this;
    }

    /**
     * 订单来源平台编码, string (50),TB&#x3D; 淘宝 、TM&#x3D;天猫 、JD&#x3D;京东、DD&#x3D;当当、PP&#x3D;拍拍、YX&#x3D;易讯、EBAY&#x3D;ebay、QQ&#x3D;QQ网购、AMAZON&#x3D;亚马逊、SN&#x3D;苏宁、GM&#x3D;国美、WPH&#x3D;唯品会、JM&#x3D;聚美、LF&#x3D;乐蜂、MGJ&#x3D;蘑菇街、JS&#x3D;聚尚、PX&#x3D;拍鞋、YT&#x3D;银泰、YHD&#x3D;1号店、VANCL&#x3D;凡客、YL&#x3D;邮乐、YG&#x3D;优购、1688&#x3D;阿里巴巴、POS&#x3D;POS门店、MIA&#x3D;蜜芽、GW&#x3D;商家官网、CT&#x3D;村淘、YJWD&#x3D;云集微店、PDD&#x3D;拼多多、OTHERS&#x3D;其他,
     * @return sourcePlatformCode
    **/

    public String getSourcePlatformCode() {
        return sourcePlatformCode;
    }

    public void setSourcePlatformCode(String sourcePlatformCode) {
        this.sourcePlatformCode = sourcePlatformCode;
    }

    public ReturnOrder returnReason(String returnReason) {
        this.returnReason = returnReason;
        return this;
    }

    /**
     * 退货原因
     * @return returnReason
    **/

    public String getReturnReason() {
        return returnReason;
    }

    public void setReturnReason(String returnReason) {
        this.returnReason = returnReason;
    }

    public ReturnOrder orderFlag(String orderFlag) {
        this.orderFlag = orderFlag;
        return this;
    }

    /**
     * 用字符串格式来表示订单标记列表(比如VISIT^ SELLER_AFFORD^SYNC_RETURN_BILL等;中间用“^”来隔开订单标记list (所 有字母全部大写) VISIT&#x3D;上门；SELLER_AFFORD&#x3D;是否卖家承担运费(默认是)SYNC_RETURN_BILL&#x3D;同时退回发票)
     * @return orderFlag
    **/

    public String getOrderFlag() {
        return orderFlag;
    }

    public void setOrderFlag(String orderFlag) {
        this.orderFlag = orderFlag;
    }

    public ReturnOrder expressCode(String expressCode) {
        this.expressCode = expressCode;
        return this;
    }

    /**
     * 运单号
     * @return expressCode
    **/

    public String getExpressCode() {
        return expressCode;
    }

    public void setExpressCode(String expressCode) {
        this.expressCode = expressCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ReturnOrder returnOrder = (ReturnOrder) o;
        return Objects.equals(this.sellerNick, returnOrder.sellerNick) &&
        Objects.equals(this.orderType, returnOrder.orderType) &&
        Objects.equals(this.buyerNick, returnOrder.buyerNick) &&
        Objects.equals(this.preDeliveryOrderCode, returnOrder.preDeliveryOrderCode) &&
        Objects.equals(this.logisticsCode, returnOrder.logisticsCode) &&
        Objects.equals(this.remark, returnOrder.remark) &&
        Objects.equals(this.sourcePlatformName, returnOrder.sourcePlatformName) &&
        Objects.equals(this.warehouseCode, returnOrder.warehouseCode) &&
        Objects.equals(this.logisticsName, returnOrder.logisticsName) &&
        Objects.equals(this.shopNick, returnOrder.shopNick) &&
        Objects.equals(this.preDeliveryOrderId, returnOrder.preDeliveryOrderId) &&
        Objects.equals(this.senderInfo, returnOrder.senderInfo) &&
        Objects.equals(this.returnOrderCode, returnOrder.returnOrderCode) &&
        Objects.equals(this.sourcePlatformCode, returnOrder.sourcePlatformCode) &&
        Objects.equals(this.returnReason, returnOrder.returnReason) &&
        Objects.equals(this.orderFlag, returnOrder.orderFlag) &&
        Objects.equals(this.expressCode, returnOrder.expressCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(sellerNick, orderType, buyerNick, preDeliveryOrderCode, logisticsCode, remark, sourcePlatformName, warehouseCode, logisticsName, shopNick, preDeliveryOrderId, senderInfo, returnOrderCode, sourcePlatformCode, returnReason, orderFlag, expressCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ReturnOrder {\n");
        
        sb.append("    sellerNick: ").append(toIndentedString(sellerNick)).append("\n");
        sb.append("    orderType: ").append(toIndentedString(orderType)).append("\n");
        sb.append("    buyerNick: ").append(toIndentedString(buyerNick)).append("\n");
        sb.append("    preDeliveryOrderCode: ").append(toIndentedString(preDeliveryOrderCode)).append("\n");
        sb.append("    logisticsCode: ").append(toIndentedString(logisticsCode)).append("\n");
        sb.append("    remark: ").append(toIndentedString(remark)).append("\n");
        sb.append("    sourcePlatformName: ").append(toIndentedString(sourcePlatformName)).append("\n");
        sb.append("    warehouseCode: ").append(toIndentedString(warehouseCode)).append("\n");
        sb.append("    logisticsName: ").append(toIndentedString(logisticsName)).append("\n");
        sb.append("    shopNick: ").append(toIndentedString(shopNick)).append("\n");
        sb.append("    preDeliveryOrderId: ").append(toIndentedString(preDeliveryOrderId)).append("\n");
        sb.append("    senderInfo: ").append(toIndentedString(senderInfo)).append("\n");
        sb.append("    returnOrderCode: ").append(toIndentedString(returnOrderCode)).append("\n");
        sb.append("    sourcePlatformCode: ").append(toIndentedString(sourcePlatformCode)).append("\n");
        sb.append("    returnReason: ").append(toIndentedString(returnReason)).append("\n");
        sb.append("    orderFlag: ").append(toIndentedString(orderFlag)).append("\n");
        sb.append("    expressCode: ").append(toIndentedString(expressCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

