/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufushopsynchronize;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import net.jdcloud.HufuStorage.model.jingdonghufushopsynchronize.ShopAddress;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 店铺
 */
@XmlRootElement(name = "shop")
@XmlAccessorType(XmlAccessType.FIELD)

public class Shop implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "shopCode")
    @SerializedName("shopCode")
    private String shopCode = null;

    @XmlElement(name = "platformShopName")
    @SerializedName("platformShopName")
    private String platformShopName = null;

    @XmlElement(name = "sourcePlatformCode")
    @SerializedName("sourcePlatformCode")
    private String sourcePlatformCode = null;

    @XmlElement(name = "ownerCode")
    @SerializedName("ownerCode")
    private String ownerCode = null;

    @XmlElement(name = "platformShopCode")
    @SerializedName("platformShopCode")
    private String platformShopCode = null;

    @XmlElement(name = "shopName")
    @SerializedName("shopName")
    private String shopName = null;

    @XmlElement(name = "shopAddress")
    @SerializedName("shopAddress")
    private ShopAddress shopAddress = null;

    @XmlElement(name = "warehouseCode")
    @SerializedName("warehouseCode")
    private String warehouseCode = null;

    public Shop shopCode(String shopCode) {
        this.shopCode = shopCode;
        return this;
    }

    /**
     * ERP店铺编码,  string (50) ,  必填
     * @return shopCode
    **/

    public String getShopCode() {
        return shopCode;
    }

    public void setShopCode(String shopCode) {
        this.shopCode = shopCode;
    }

    public Shop platformShopName(String platformShopName) {
        this.platformShopName = platformShopName;
        return this;
    }

    /**
     * 平台店铺名称
     * @return platformShopName
    **/

    public String getPlatformShopName() {
        return platformShopName;
    }

    public void setPlatformShopName(String platformShopName) {
        this.platformShopName = platformShopName;
    }

    public Shop sourcePlatformCode(String sourcePlatformCode) {
        this.sourcePlatformCode = sourcePlatformCode;
        return this;
    }

    /**
     * 来源平台编码, string (50) , 必填,TB&#x3D; 淘宝 、TM&#x3D;天猫 、JD&#x3D;京东、DD&#x3D;当当、PP&#x3D;拍拍、YX&#x3D;易讯、EBAY&#x3D;ebay、QQ&#x3D;QQ网购、AMAZON&#x3D;亚马逊、SN&#x3D;苏宁、GM&#x3D;国美、WPH&#x3D;唯品会、JM&#x3D;聚美、LF&#x3D;乐蜂、MGJ&#x3D;蘑菇街、JS&#x3D;聚尚、PX&#x3D;拍鞋、YT&#x3D;银泰、YHD&#x3D;1号店、VANCL&#x3D;凡客、YL&#x3D;邮乐、YG&#x3D;优购、1688&#x3D;阿里巴巴、POS&#x3D;POS门店、MIA&#x3D;蜜芽、GW&#x3D;商家官网、CT&#x3D;村淘、YJWD&#x3D;云集微店、OTHERS&#x3D;其他,  (只传英文编码)
     * @return sourcePlatformCode
    **/

    public String getSourcePlatformCode() {
        return sourcePlatformCode;
    }

    public void setSourcePlatformCode(String sourcePlatformCode) {
        this.sourcePlatformCode = sourcePlatformCode;
    }

    public Shop ownerCode(String ownerCode) {
        this.ownerCode = ownerCode;
        return this;
    }

    /**
     * 货主编码, string (50) , 必填
     * @return ownerCode
    **/

    public String getOwnerCode() {
        return ownerCode;
    }

    public void setOwnerCode(String ownerCode) {
        this.ownerCode = ownerCode;
    }

    public Shop platformShopCode(String platformShopCode) {
        this.platformShopCode = platformShopCode;
        return this;
    }

    /**
     * 平台店铺Id
     * @return platformShopCode
    **/

    public String getPlatformShopCode() {
        return platformShopCode;
    }

    public void setPlatformShopCode(String platformShopCode) {
        this.platformShopCode = platformShopCode;
    }

    public Shop shopName(String shopName) {
        this.shopName = shopName;
        return this;
    }

    /**
     * ERP店铺名称，string (50)
     * @return shopName
    **/

    public String getShopName() {
        return shopName;
    }

    public void setShopName(String shopName) {
        this.shopName = shopName;
    }

    public Shop shopAddress(ShopAddress shopAddress) {
        this.shopAddress = shopAddress;
        return this;
    }

    /**
     * Get shopAddress
     * @return shopAddress
    **/

    public ShopAddress getShopAddress() {
        return shopAddress;
    }

    public void setShopAddress(ShopAddress shopAddress) {
        this.shopAddress = shopAddress;
    }

    public Shop warehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
        return this;
    }

    /**
     * 仓库编码, string (50)，必填
     * @return warehouseCode
    **/

    public String getWarehouseCode() {
        return warehouseCode;
    }

    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Shop shop = (Shop) o;
        return Objects.equals(this.shopCode, shop.shopCode) &&
        Objects.equals(this.platformShopName, shop.platformShopName) &&
        Objects.equals(this.sourcePlatformCode, shop.sourcePlatformCode) &&
        Objects.equals(this.ownerCode, shop.ownerCode) &&
        Objects.equals(this.platformShopCode, shop.platformShopCode) &&
        Objects.equals(this.shopName, shop.shopName) &&
        Objects.equals(this.shopAddress, shop.shopAddress) &&
        Objects.equals(this.warehouseCode, shop.warehouseCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(shopCode, platformShopName, sourcePlatformCode, ownerCode, platformShopCode, shopName, shopAddress, warehouseCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class Shop {\n");
        
        sb.append("    shopCode: ").append(toIndentedString(shopCode)).append("\n");
        sb.append("    platformShopName: ").append(toIndentedString(platformShopName)).append("\n");
        sb.append("    sourcePlatformCode: ").append(toIndentedString(sourcePlatformCode)).append("\n");
        sb.append("    ownerCode: ").append(toIndentedString(ownerCode)).append("\n");
        sb.append("    platformShopCode: ").append(toIndentedString(platformShopCode)).append("\n");
        sb.append("    shopName: ").append(toIndentedString(shopName)).append("\n");
        sb.append("    shopAddress: ").append(toIndentedString(shopAddress)).append("\n");
        sb.append("    warehouseCode: ").append(toIndentedString(warehouseCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

