/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufushopsynchronize;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 店铺地址
 */
@XmlRootElement(name = "shopAddress")
@XmlAccessorType(XmlAccessType.FIELD)

public class ShopAddress implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "area")
    @SerializedName("area")
    private String area = null;

    @XmlElement(name = "zipCode")
    @SerializedName("zipCode")
    private String zipCode = null;

    @XmlElement(name = "province")
    @SerializedName("province")
    private String province = null;

    @XmlElement(name = "town")
    @SerializedName("town")
    private String town = null;

    @XmlElement(name = "city")
    @SerializedName("city")
    private String city = null;

    @XmlElement(name = "detailAddress")
    @SerializedName("detailAddress")
    private String detailAddress = null;

    public ShopAddress area(String area) {
        this.area = area;
        return this;
    }

    /**
     * 区域, string (50)
     * @return area
    **/

    public String getArea() {
        return area;
    }

    public void setArea(String area) {
        this.area = area;
    }

    public ShopAddress zipCode(String zipCode) {
        this.zipCode = zipCode;
        return this;
    }

    /**
     * 邮编, string (50)
     * @return zipCode
    **/

    public String getZipCode() {
        return zipCode;
    }

    public void setZipCode(String zipCode) {
        this.zipCode = zipCode;
    }

    public ShopAddress province(String province) {
        this.province = province;
        return this;
    }

    /**
     * 省份, string (50)
     * @return province
    **/

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public ShopAddress town(String town) {
        this.town = town;
        return this;
    }

    /**
     * 村镇, string (50)
     * @return town
    **/

    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    public ShopAddress city(String city) {
        this.city = city;
        return this;
    }

    /**
     * 城市, string (50)
     * @return city
    **/

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public ShopAddress detailAddress(String detailAddress) {
        this.detailAddress = detailAddress;
        return this;
    }

    /**
     * 详细地址, string (200)
     * @return detailAddress
    **/

    public String getDetailAddress() {
        return detailAddress;
    }

    public void setDetailAddress(String detailAddress) {
        this.detailAddress = detailAddress;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ShopAddress shopAddress = (ShopAddress) o;
        return Objects.equals(this.area, shopAddress.area) &&
        Objects.equals(this.zipCode, shopAddress.zipCode) &&
        Objects.equals(this.province, shopAddress.province) &&
        Objects.equals(this.town, shopAddress.town) &&
        Objects.equals(this.city, shopAddress.city) &&
        Objects.equals(this.detailAddress, shopAddress.detailAddress);
    }

    @Override
    public int hashCode() {
        return Objects.hash(area, zipCode, province, town, city, detailAddress);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ShopAddress {\n");
        
        sb.append("    area: ").append(toIndentedString(area)).append("\n");
        sb.append("    zipCode: ").append(toIndentedString(zipCode)).append("\n");
        sb.append("    province: ").append(toIndentedString(province)).append("\n");
        sb.append("    town: ").append(toIndentedString(town)).append("\n");
        sb.append("    city: ").append(toIndentedString(city)).append("\n");
        sb.append("    detailAddress: ").append(toIndentedString(detailAddress)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

