/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufusnreport;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.jdcloud.HufuStorage.model.jingdonghufusnreport.DeliveryOrder;
import net.jdcloud.HufuStorage.model.jingdonghufusnreport.SnItems;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * SnReportRequest
 */
@XmlRootElement(name = "SnReportRequest")
@XmlAccessorType(XmlAccessType.FIELD)

public class SnReportRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "totalPage")
    @SerializedName("totalPage")
    @Required
    private Integer totalPage = null;

    @XmlElement(name = "pageSize")
    @SerializedName("pageSize")
    @Required
    private Integer pageSize = null;

    @XmlElementWrapper(name = "snItems")
    @XmlElement(name = "snItems")
    @SerializedName("snItems")
    private List<SnItems> snItems = null;

    @XmlElement(name = "inner")
    @SerializedName("extendProps")
    private Map<String, String> extendProps = null;

    @XmlElement(name = "deliveryOrder")
    @SerializedName("deliveryOrder")
    private DeliveryOrder deliveryOrder = null;

    @XmlElement(name = "currentPage")
    @SerializedName("currentPage")
    @Required
    private Integer currentPage = null;

    public SnReportRequest totalPage(Integer totalPage) {
        this.totalPage = totalPage;
        return this;
    }

    /**
     * 总页数
     * @return totalPage
    **/

    public Integer getTotalPage() {
        return totalPage;
    }

    public void setTotalPage(Integer totalPage) {
        this.totalPage = totalPage;
    }

    public SnReportRequest pageSize(Integer pageSize) {
        this.pageSize = pageSize;
        return this;
    }

    /**
     * 每页记录的条数
     * @return pageSize
    **/

    public Integer getPageSize() {
        return pageSize;
    }

    public void setPageSize(Integer pageSize) {
        this.pageSize = pageSize;
    }

    public SnReportRequest snItems(List<SnItems> snItems) {
        this.snItems = snItems;
        return this;
    }

    public SnReportRequest addSnItemsItem(SnItems snItemsItem) {
        if (this.snItems == null) {
            this.snItems = new ArrayList<SnItems>();
        }
        this.snItems.add(snItemsItem);
        return this;
    }

    /**
     * 商品列表
     * @return snItems
    **/

    public List<SnItems> getSnItems() {
        return snItems;
    }

    public void setSnItems(List<SnItems> snItems) {
        this.snItems = snItems;
    }

    public SnReportRequest extendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
        return this;
    }

    public SnReportRequest putExtendPropsItem(String key, String extendPropsItem) {
        if (this.extendProps == null) {
            this.extendProps = new HashMap<String, String>();
        }
        this.extendProps.put(key, extendPropsItem);
        return this;
    }

    /**
     * 扩展属性(map类型)
     * @return extendProps
    **/

    public Map<String, String> getExtendProps() {
        return extendProps;
    }

    public void setExtendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
    }

    public SnReportRequest deliveryOrder(DeliveryOrder deliveryOrder) {
        this.deliveryOrder = deliveryOrder;
        return this;
    }

    /**
     * Get deliveryOrder
     * @return deliveryOrder
    **/

    public DeliveryOrder getDeliveryOrder() {
        return deliveryOrder;
    }

    public void setDeliveryOrder(DeliveryOrder deliveryOrder) {
        this.deliveryOrder = deliveryOrder;
    }

    public SnReportRequest currentPage(Integer currentPage) {
        this.currentPage = currentPage;
        return this;
    }

    /**
     * 当前页(从1开始)
     * @return currentPage
    **/

    public Integer getCurrentPage() {
        return currentPage;
    }

    public void setCurrentPage(Integer currentPage) {
        this.currentPage = currentPage;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        SnReportRequest snReportRequest = (SnReportRequest) o;
        return Objects.equals(this.totalPage, snReportRequest.totalPage) &&
        Objects.equals(this.pageSize, snReportRequest.pageSize) &&
        Objects.equals(this.snItems, snReportRequest.snItems) &&
        Objects.equals(this.extendProps, snReportRequest.extendProps) &&
        Objects.equals(this.deliveryOrder, snReportRequest.deliveryOrder) &&
        Objects.equals(this.currentPage, snReportRequest.currentPage);
    }

    @Override
    public int hashCode() {
        return Objects.hash(totalPage, pageSize, snItems, extendProps, deliveryOrder, currentPage);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class SnReportRequest {\n");
        
        sb.append("    totalPage: ").append(toIndentedString(totalPage)).append("\n");
        sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
        sb.append("    snItems: ").append(toIndentedString(snItems)).append("\n");
        sb.append("    extendProps: ").append(toIndentedString(extendProps)).append("\n");
        sb.append("    deliveryOrder: ").append(toIndentedString(deliveryOrder)).append("\n");
        sb.append("    currentPage: ").append(toIndentedString(currentPage)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

