/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufustockoutconfirm;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 出库单信息
 */
@XmlRootElement(name = "deliveryOrder")
@XmlAccessorType(XmlAccessType.FIELD)

public class DeliveryOrder implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "logisticsName")
    @SerializedName("logisticsName")
    private String logisticsName = null;

    @XmlElement(name = "orderType")
    @SerializedName("orderType")
    @Required
    private String orderType = null;

    @XmlElement(name = "totalOrderLines")
    @SerializedName("totalOrderLines")
    private Integer totalOrderLines = null;

    @XmlElement(name = "outBizCode")
    @SerializedName("outBizCode")
    private String outBizCode = null;

    @XmlElement(name = "expressCode")
    @SerializedName("expressCode")
    private String expressCode = null;

    @XmlElement(name = "logisticsCode")
    @SerializedName("logisticsCode")
    private String logisticsCode = null;

    @XmlElement(name = "orderConfirmTime")
    @SerializedName("orderConfirmTime")
    private String orderConfirmTime = null;

    @XmlElement(name = "deliveryOrderCode")
    @SerializedName("deliveryOrderCode")
    @Required
    private String deliveryOrderCode = null;

    @XmlElement(name = "confirmType")
    @SerializedName("confirmType")
    private String confirmType = null;

    @XmlElement(name = "warehouseCode")
    @SerializedName("warehouseCode")
    @Required
    private String warehouseCode = null;

    @XmlElement(name = "deliveryOrderId")
    @SerializedName("deliveryOrderId")
    private String deliveryOrderId = null;

    @XmlElement(name = "status")
    @SerializedName("status")
    private String status = null;

    public DeliveryOrder logisticsName(String logisticsName) {
        this.logisticsName = logisticsName;
        return this;
    }

    /**
     * 物流公司名称(包括干线物流公司等)
     * @return logisticsName
    **/

    public String getLogisticsName() {
        return logisticsName;
    }

    public void setLogisticsName(String logisticsName) {
        this.logisticsName = logisticsName;
    }

    public DeliveryOrder orderType(String orderType) {
        this.orderType = orderType;
        return this;
    }

    /**
     * 出库单类型(PTCK&#x3D;普通出库单;DBCK&#x3D;调拨出库;B2BCK&#x3D;B2B出库;QTCK&#x3D;其他出库;CGTH&#x3D;采购退货出库单;XNCK&#x3D;虚拟出库单, JITCK&#x3D;唯品出库)
     * @return orderType
    **/

    public String getOrderType() {
        return orderType;
    }

    public void setOrderType(String orderType) {
        this.orderType = orderType;
    }

    public DeliveryOrder totalOrderLines(Integer totalOrderLines) {
        this.totalOrderLines = totalOrderLines;
        return this;
    }

    /**
     * 单据总行数(当单据需要分多个请求发送时;发送方需要将totalOrderLines填入;接收方收到后;根据实际接收到的条数和totalOrderLines进行比对;如果小于;则继续等待接收请求。如果等于;则表示该单据的所有请求发送完成.)
     * @return totalOrderLines
    **/

    public Integer getTotalOrderLines() {
        return totalOrderLines;
    }

    public void setTotalOrderLines(Integer totalOrderLines) {
        this.totalOrderLines = totalOrderLines;
    }

    public DeliveryOrder outBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
        return this;
    }

    /**
     * 外部业务编码
     * @return outBizCode
    **/

    public String getOutBizCode() {
        return outBizCode;
    }

    public void setOutBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
    }

    public DeliveryOrder expressCode(String expressCode) {
        this.expressCode = expressCode;
        return this;
    }

    /**
     * 运单号
     * @return expressCode
    **/

    public String getExpressCode() {
        return expressCode;
    }

    public void setExpressCode(String expressCode) {
        this.expressCode = expressCode;
    }

    public DeliveryOrder logisticsCode(String logisticsCode) {
        this.logisticsCode = logisticsCode;
        return this;
    }

    /**
     * 物流公司编码
     * @return logisticsCode
    **/

    public String getLogisticsCode() {
        return logisticsCode;
    }

    public void setLogisticsCode(String logisticsCode) {
        this.logisticsCode = logisticsCode;
    }

    public DeliveryOrder orderConfirmTime(String orderConfirmTime) {
        this.orderConfirmTime = orderConfirmTime;
        return this;
    }

    /**
     * 订单完成时间
     * @return orderConfirmTime
    **/

    public String getOrderConfirmTime() {
        return orderConfirmTime;
    }

    public void setOrderConfirmTime(String orderConfirmTime) {
        this.orderConfirmTime = orderConfirmTime;
    }

    public DeliveryOrder deliveryOrderCode(String deliveryOrderCode) {
        this.deliveryOrderCode = deliveryOrderCode;
        return this;
    }

    /**
     * 出库单号
     * @return deliveryOrderCode
    **/

    public String getDeliveryOrderCode() {
        return deliveryOrderCode;
    }

    public void setDeliveryOrderCode(String deliveryOrderCode) {
        this.deliveryOrderCode = deliveryOrderCode;
    }

    public DeliveryOrder confirmType(String confirmType) {
        this.confirmType = confirmType;
        return this;
    }

    /**
     * 支持出库单多次发货的状态位
     * @return confirmType
    **/

    public String getConfirmType() {
        return confirmType;
    }

    public void setConfirmType(String confirmType) {
        this.confirmType = confirmType;
    }

    public DeliveryOrder warehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
        return this;
    }

    /**
     * 仓库编码(统仓统配等无需ERP指定仓储编码的情况填OTHER)
     * @return warehouseCode
    **/

    public String getWarehouseCode() {
        return warehouseCode;
    }

    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
    }

    public DeliveryOrder deliveryOrderId(String deliveryOrderId) {
        this.deliveryOrderId = deliveryOrderId;
        return this;
    }

    /**
     * 仓储系统出库单号
     * @return deliveryOrderId
    **/

    public String getDeliveryOrderId() {
        return deliveryOrderId;
    }

    public void setDeliveryOrderId(String deliveryOrderId) {
        this.deliveryOrderId = deliveryOrderId;
    }

    public DeliveryOrder status(String status) {
        this.status = status;
        return this;
    }

    /**
     * 出库单状态
     * @return status
    **/

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        DeliveryOrder deliveryOrder = (DeliveryOrder) o;
        return Objects.equals(this.logisticsName, deliveryOrder.logisticsName) &&
        Objects.equals(this.orderType, deliveryOrder.orderType) &&
        Objects.equals(this.totalOrderLines, deliveryOrder.totalOrderLines) &&
        Objects.equals(this.outBizCode, deliveryOrder.outBizCode) &&
        Objects.equals(this.expressCode, deliveryOrder.expressCode) &&
        Objects.equals(this.logisticsCode, deliveryOrder.logisticsCode) &&
        Objects.equals(this.orderConfirmTime, deliveryOrder.orderConfirmTime) &&
        Objects.equals(this.deliveryOrderCode, deliveryOrder.deliveryOrderCode) &&
        Objects.equals(this.confirmType, deliveryOrder.confirmType) &&
        Objects.equals(this.warehouseCode, deliveryOrder.warehouseCode) &&
        Objects.equals(this.deliveryOrderId, deliveryOrder.deliveryOrderId) &&
        Objects.equals(this.status, deliveryOrder.status);
    }

    @Override
    public int hashCode() {
        return Objects.hash(logisticsName, orderType, totalOrderLines, outBizCode, expressCode, logisticsCode, orderConfirmTime, deliveryOrderCode, confirmType, warehouseCode, deliveryOrderId, status);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class DeliveryOrder {\n");
        
        sb.append("    logisticsName: ").append(toIndentedString(logisticsName)).append("\n");
        sb.append("    orderType: ").append(toIndentedString(orderType)).append("\n");
        sb.append("    totalOrderLines: ").append(toIndentedString(totalOrderLines)).append("\n");
        sb.append("    outBizCode: ").append(toIndentedString(outBizCode)).append("\n");
        sb.append("    expressCode: ").append(toIndentedString(expressCode)).append("\n");
        sb.append("    logisticsCode: ").append(toIndentedString(logisticsCode)).append("\n");
        sb.append("    orderConfirmTime: ").append(toIndentedString(orderConfirmTime)).append("\n");
        sb.append("    deliveryOrderCode: ").append(toIndentedString(deliveryOrderCode)).append("\n");
        sb.append("    confirmType: ").append(toIndentedString(confirmType)).append("\n");
        sb.append("    warehouseCode: ").append(toIndentedString(warehouseCode)).append("\n");
        sb.append("    deliveryOrderId: ").append(toIndentedString(deliveryOrderId)).append("\n");
        sb.append("    status: ").append(toIndentedString(status)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

