/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufustockoutconfirm;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import net.jdcloud.HufuStorage.model.jingdonghufustockoutconfirm.Batchs;
import net.jdcloud.HufuStorage.model.jingdonghufustockoutconfirm.SnList;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 
 */
@XmlRootElement(name = "orderLines")
@XmlAccessorType(XmlAccessType.FIELD)

public class OrderLines implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "orderLineNo")
    @SerializedName("orderLineNo")
    private String orderLineNo = null;

    @XmlElement(name = "inventoryType")
    @SerializedName("inventoryType")
    private String inventoryType = null;

    @XmlElement(name = "itemCode")
    @SerializedName("itemCode")
    @Required
    private String itemCode = null;

    @XmlElement(name = "batchCode")
    @SerializedName("batchCode")
    private String batchCode = null;

    @XmlElement(name = "actualQty")
    @SerializedName("actualQty")
    @Required
    private Integer actualQty = null;

    @XmlElement(name = "productDate")
    @SerializedName("productDate")
    private String productDate = null;

    @XmlElement(name = "itemId")
    @SerializedName("itemId")
    private String itemId = null;

    @XmlElement(name = "produceCode")
    @SerializedName("produceCode")
    private String produceCode = null;

    @XmlElementWrapper(name = "batchs")
    @XmlElement(name = "batchs")
    @SerializedName("batchs")
    private List<Batchs> batchs = null;

    @XmlElement(name = "itemName")
    @SerializedName("itemName")
    private String itemName = null;

    @XmlElement(name = "unit")
    @SerializedName("unit")
    private String unit = null;

    @XmlElement(name = "outBizCode")
    @SerializedName("outBizCode")
    private String outBizCode = null;

    @XmlElement(name = "snList")
    @SerializedName("snList")
    private SnList snList = null;

    @XmlElement(name = "expireDate")
    @SerializedName("expireDate")
    private String expireDate = null;

    public OrderLines orderLineNo(String orderLineNo) {
        this.orderLineNo = orderLineNo;
        return this;
    }

    /**
     * 单据行号
     * @return orderLineNo
    **/

    public String getOrderLineNo() {
        return orderLineNo;
    }

    public void setOrderLineNo(String orderLineNo) {
        this.orderLineNo = orderLineNo;
    }

    public OrderLines inventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
        return this;
    }

    /**
     * 库存类型
     * @return inventoryType
    **/

    public String getInventoryType() {
        return inventoryType;
    }

    public void setInventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
    }

    public OrderLines itemCode(String itemCode) {
        this.itemCode = itemCode;
        return this;
    }

    /**
     * 商品编码
     * @return itemCode
    **/

    public String getItemCode() {
        return itemCode;
    }

    public void setItemCode(String itemCode) {
        this.itemCode = itemCode;
    }

    public OrderLines batchCode(String batchCode) {
        this.batchCode = batchCode;
        return this;
    }

    /**
     * 批次编号
     * @return batchCode
    **/

    public String getBatchCode() {
        return batchCode;
    }

    public void setBatchCode(String batchCode) {
        this.batchCode = batchCode;
    }

    public OrderLines actualQty(Integer actualQty) {
        this.actualQty = actualQty;
        return this;
    }

    /**
     * 实发商品数量
     * @return actualQty
    **/

    public Integer getActualQty() {
        return actualQty;
    }

    public void setActualQty(Integer actualQty) {
        this.actualQty = actualQty;
    }

    public OrderLines productDate(String productDate) {
        this.productDate = productDate;
        return this;
    }

    /**
     * 生产日期
     * @return productDate
    **/

    public String getProductDate() {
        return productDate;
    }

    public void setProductDate(String productDate) {
        this.productDate = productDate;
    }

    public OrderLines itemId(String itemId) {
        this.itemId = itemId;
        return this;
    }

    /**
     * 商品仓储系统编码
     * @return itemId
    **/

    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }

    public OrderLines produceCode(String produceCode) {
        this.produceCode = produceCode;
        return this;
    }

    /**
     * 生产批号
     * @return produceCode
    **/

    public String getProduceCode() {
        return produceCode;
    }

    public void setProduceCode(String produceCode) {
        this.produceCode = produceCode;
    }

    public OrderLines batchs(List<Batchs> batchs) {
        this.batchs = batchs;
        return this;
    }

    public OrderLines addBatchsItem(Batchs batchsItem) {
        if (this.batchs == null) {
            this.batchs = new ArrayList<Batchs>();
        }
        this.batchs.add(batchsItem);
        return this;
    }

    /**
     * batchs
     * @return batchs
    **/

    public List<Batchs> getBatchs() {
        return batchs;
    }

    public void setBatchs(List<Batchs> batchs) {
        this.batchs = batchs;
    }

    public OrderLines itemName(String itemName) {
        this.itemName = itemName;
        return this;
    }

    /**
     * 商品名称
     * @return itemName
    **/

    public String getItemName() {
        return itemName;
    }

    public void setItemName(String itemName) {
        this.itemName = itemName;
    }

    public OrderLines unit(String unit) {
        this.unit = unit;
        return this;
    }

    /**
     * 单位
     * @return unit
    **/

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public OrderLines outBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
        return this;
    }

    /**
     * 外部业务编码
     * @return outBizCode
    **/

    public String getOutBizCode() {
        return outBizCode;
    }

    public void setOutBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
    }

    public OrderLines snList(SnList snList) {
        this.snList = snList;
        return this;
    }

    /**
     * Get snList
     * @return snList
    **/

    public SnList getSnList() {
        return snList;
    }

    public void setSnList(SnList snList) {
        this.snList = snList;
    }

    public OrderLines expireDate(String expireDate) {
        this.expireDate = expireDate;
        return this;
    }

    /**
     * 过期日期
     * @return expireDate
    **/

    public String getExpireDate() {
        return expireDate;
    }

    public void setExpireDate(String expireDate) {
        this.expireDate = expireDate;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        OrderLines orderLines = (OrderLines) o;
        return Objects.equals(this.orderLineNo, orderLines.orderLineNo) &&
        Objects.equals(this.inventoryType, orderLines.inventoryType) &&
        Objects.equals(this.itemCode, orderLines.itemCode) &&
        Objects.equals(this.batchCode, orderLines.batchCode) &&
        Objects.equals(this.actualQty, orderLines.actualQty) &&
        Objects.equals(this.productDate, orderLines.productDate) &&
        Objects.equals(this.itemId, orderLines.itemId) &&
        Objects.equals(this.produceCode, orderLines.produceCode) &&
        Objects.equals(this.batchs, orderLines.batchs) &&
        Objects.equals(this.itemName, orderLines.itemName) &&
        Objects.equals(this.unit, orderLines.unit) &&
        Objects.equals(this.outBizCode, orderLines.outBizCode) &&
        Objects.equals(this.snList, orderLines.snList) &&
        Objects.equals(this.expireDate, orderLines.expireDate);
    }

    @Override
    public int hashCode() {
        return Objects.hash(orderLineNo, inventoryType, itemCode, batchCode, actualQty, productDate, itemId, produceCode, batchs, itemName, unit, outBizCode, snList, expireDate);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class OrderLines {\n");
        
        sb.append("    orderLineNo: ").append(toIndentedString(orderLineNo)).append("\n");
        sb.append("    inventoryType: ").append(toIndentedString(inventoryType)).append("\n");
        sb.append("    itemCode: ").append(toIndentedString(itemCode)).append("\n");
        sb.append("    batchCode: ").append(toIndentedString(batchCode)).append("\n");
        sb.append("    actualQty: ").append(toIndentedString(actualQty)).append("\n");
        sb.append("    productDate: ").append(toIndentedString(productDate)).append("\n");
        sb.append("    itemId: ").append(toIndentedString(itemId)).append("\n");
        sb.append("    produceCode: ").append(toIndentedString(produceCode)).append("\n");
        sb.append("    batchs: ").append(toIndentedString(batchs)).append("\n");
        sb.append("    itemName: ").append(toIndentedString(itemName)).append("\n");
        sb.append("    unit: ").append(toIndentedString(unit)).append("\n");
        sb.append("    outBizCode: ").append(toIndentedString(outBizCode)).append("\n");
        sb.append("    snList: ").append(toIndentedString(snList)).append("\n");
        sb.append("    expireDate: ").append(toIndentedString(expireDate)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

