/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufustoreprocessconfirm;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.jdcloud.HufuStorage.model.jingdonghufustoreprocessconfirm.ProductItems;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * StoreProcessConfirmRequest
 */
@XmlRootElement(name = "StoreProcessConfirmRequest")
@XmlAccessorType(XmlAccessType.FIELD)

public class StoreProcessConfirmRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "orderType")
    @SerializedName("orderType")
    @Required
    private String orderType = null;

    @XmlElement(name = "orderCompleteTime")
    @SerializedName("orderCompleteTime")
    @Required
    private String orderCompleteTime = null;

    @XmlElementWrapper(name = "productItems")
    @XmlElement(name = "productItems")
    @SerializedName("productItems")
    private List<ProductItems> productItems = null;

    @XmlElement(name = "outBizCode")
    @SerializedName("outBizCode")
    @Required
    private String outBizCode = null;

    @XmlElement(name = "ownerCode")
    @SerializedName("ownerCode")
    private String ownerCode = null;

    @XmlElement(name = "processOrderId")
    @SerializedName("processOrderId")
    private String processOrderId = null;

    @XmlElementWrapper(name = "materialitems")
    @XmlElement(name = "productItems")
    @SerializedName("materialitems")
    private List<ProductItems> materialitems = null;

    @XmlElement(name = "inner")
    @SerializedName("extendProps")
    private Map<String, String> extendProps = null;

    @XmlElement(name = "remark")
    @SerializedName("remark")
    private String remark = null;

    @XmlElement(name = "processOrderCode")
    @SerializedName("processOrderCode")
    @Required
    private String processOrderCode = null;

    @XmlElement(name = "actualQty")
    @SerializedName("actualQty")
    private Integer actualQty = null;

    public StoreProcessConfirmRequest orderType(String orderType) {
        this.orderType = orderType;
        return this;
    }

    /**
     * 单据类型(CNJG&#x3D;仓内加工作业单)
     * @return orderType
    **/

    public String getOrderType() {
        return orderType;
    }

    public void setOrderType(String orderType) {
        this.orderType = orderType;
    }

    public StoreProcessConfirmRequest orderCompleteTime(String orderCompleteTime) {
        this.orderCompleteTime = orderCompleteTime;
        return this;
    }

    /**
     * 加工单完成时间(YYYY-MM-DD HH:MM:SS)
     * @return orderCompleteTime
    **/

    public String getOrderCompleteTime() {
        return orderCompleteTime;
    }

    public void setOrderCompleteTime(String orderCompleteTime) {
        this.orderCompleteTime = orderCompleteTime;
    }

    public StoreProcessConfirmRequest productItems(List<ProductItems> productItems) {
        this.productItems = productItems;
        return this;
    }

    public StoreProcessConfirmRequest addProductItemsItem(ProductItems productItemsItem) {
        if (this.productItems == null) {
            this.productItems = new ArrayList<ProductItems>();
        }
        this.productItems.add(productItemsItem);
        return this;
    }

    /**
     * 加工商品列表
     * @return productItems
    **/

    public List<ProductItems> getProductItems() {
        return productItems;
    }

    public void setProductItems(List<ProductItems> productItems) {
        this.productItems = productItems;
    }

    public StoreProcessConfirmRequest outBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
        return this;
    }

    /**
     * 外部业务编码(一个合作伙伴中要求唯一多次确认时;每次传入要求唯一(一般传入WMS损益单据编码))
     * @return outBizCode
    **/

    public String getOutBizCode() {
        return outBizCode;
    }

    public void setOutBizCode(String outBizCode) {
        this.outBizCode = outBizCode;
    }

    public StoreProcessConfirmRequest ownerCode(String ownerCode) {
        this.ownerCode = ownerCode;
        return this;
    }

    /**
     * 货主编码
     * @return ownerCode
    **/

    public String getOwnerCode() {
        return ownerCode;
    }

    public void setOwnerCode(String ownerCode) {
        this.ownerCode = ownerCode;
    }

    public StoreProcessConfirmRequest processOrderId(String processOrderId) {
        this.processOrderId = processOrderId;
        return this;
    }

    /**
     * 仓储系统加工单ID
     * @return processOrderId
    **/

    public String getProcessOrderId() {
        return processOrderId;
    }

    public void setProcessOrderId(String processOrderId) {
        this.processOrderId = processOrderId;
    }

    public StoreProcessConfirmRequest materialitems(List<ProductItems> materialitems) {
        this.materialitems = materialitems;
        return this;
    }

    public StoreProcessConfirmRequest addMaterialitemsItem(ProductItems materialitemsItem) {
        if (this.materialitems == null) {
            this.materialitems = new ArrayList<ProductItems>();
        }
        this.materialitems.add(materialitemsItem);
        return this;
    }

    /**
     * 加工商品列表
     * @return materialitems
    **/

    public List<ProductItems> getMaterialitems() {
        return materialitems;
    }

    public void setMaterialitems(List<ProductItems> materialitems) {
        this.materialitems = materialitems;
    }

    public StoreProcessConfirmRequest extendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
        return this;
    }

    public StoreProcessConfirmRequest putExtendPropsItem(String key, String extendPropsItem) {
        if (this.extendProps == null) {
            this.extendProps = new HashMap<String, String>();
        }
        this.extendProps.put(key, extendPropsItem);
        return this;
    }

    /**
     * 扩展属性(map类型)
     * @return extendProps
    **/

    public Map<String, String> getExtendProps() {
        return extendProps;
    }

    public void setExtendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
    }

    public StoreProcessConfirmRequest remark(String remark) {
        this.remark = remark;
        return this;
    }

    /**
     * 备注
     * @return remark
    **/

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public StoreProcessConfirmRequest processOrderCode(String processOrderCode) {
        this.processOrderCode = processOrderCode;
        return this;
    }

    /**
     * 加工单编码
     * @return processOrderCode
    **/

    public String getProcessOrderCode() {
        return processOrderCode;
    }

    public void setProcessOrderCode(String processOrderCode) {
        this.processOrderCode = processOrderCode;
    }

    public StoreProcessConfirmRequest actualQty(Integer actualQty) {
        this.actualQty = actualQty;
        return this;
    }

    /**
     * 实际作业总数量
     * @return actualQty
    **/

    public Integer getActualQty() {
        return actualQty;
    }

    public void setActualQty(Integer actualQty) {
        this.actualQty = actualQty;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        StoreProcessConfirmRequest storeProcessConfirmRequest = (StoreProcessConfirmRequest) o;
        return Objects.equals(this.orderType, storeProcessConfirmRequest.orderType) &&
        Objects.equals(this.orderCompleteTime, storeProcessConfirmRequest.orderCompleteTime) &&
        Objects.equals(this.productItems, storeProcessConfirmRequest.productItems) &&
        Objects.equals(this.outBizCode, storeProcessConfirmRequest.outBizCode) &&
        Objects.equals(this.ownerCode, storeProcessConfirmRequest.ownerCode) &&
        Objects.equals(this.processOrderId, storeProcessConfirmRequest.processOrderId) &&
        Objects.equals(this.materialitems, storeProcessConfirmRequest.materialitems) &&
        Objects.equals(this.extendProps, storeProcessConfirmRequest.extendProps) &&
        Objects.equals(this.remark, storeProcessConfirmRequest.remark) &&
        Objects.equals(this.processOrderCode, storeProcessConfirmRequest.processOrderCode) &&
        Objects.equals(this.actualQty, storeProcessConfirmRequest.actualQty);
    }

    @Override
    public int hashCode() {
        return Objects.hash(orderType, orderCompleteTime, productItems, outBizCode, ownerCode, processOrderId, materialitems, extendProps, remark, processOrderCode, actualQty);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class StoreProcessConfirmRequest {\n");
        
        sb.append("    orderType: ").append(toIndentedString(orderType)).append("\n");
        sb.append("    orderCompleteTime: ").append(toIndentedString(orderCompleteTime)).append("\n");
        sb.append("    productItems: ").append(toIndentedString(productItems)).append("\n");
        sb.append("    outBizCode: ").append(toIndentedString(outBizCode)).append("\n");
        sb.append("    ownerCode: ").append(toIndentedString(ownerCode)).append("\n");
        sb.append("    processOrderId: ").append(toIndentedString(processOrderId)).append("\n");
        sb.append("    materialitems: ").append(toIndentedString(materialitems)).append("\n");
        sb.append("    extendProps: ").append(toIndentedString(extendProps)).append("\n");
        sb.append("    remark: ").append(toIndentedString(remark)).append("\n");
        sb.append("    processOrderCode: ").append(toIndentedString(processOrderCode)).append("\n");
        sb.append("    actualQty: ").append(toIndentedString(actualQty)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

