/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufustoreprocesscreate;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import net.jdcloud.HufuStorage.model.jingdonghufustoreprocesscreate.Materialitems;
import net.jdcloud.HufuStorage.model.jingdonghufustoreprocesscreate.ProductItems;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * StoreProcessCreateRequest
 */
@XmlRootElement(name = "StoreProcessCreateRequest")
@XmlAccessorType(XmlAccessType.FIELD)

public class StoreProcessCreateRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "serviceType")
    @SerializedName("serviceType")
    @Required
    private String serviceType = null;

    @XmlElement(name = "orderType")
    @SerializedName("orderType")
    @Required
    private String orderType = null;

    @XmlElement(name = "planQty")
    @SerializedName("planQty")
    private Integer planQty = null;

    @XmlElementWrapper(name = "productItems")
    @XmlElement(name = "productItems")
    @SerializedName("productItems")
    private List<ProductItems> productItems = null;

    @XmlElement(name = "orderCreateTime")
    @SerializedName("orderCreateTime")
    @Required
    private String orderCreateTime = null;

    @XmlElement(name = "planTime")
    @SerializedName("planTime")
    private String planTime = null;

    @XmlElementWrapper(name = "materialitems")
    @XmlElement(name = "materialitems")
    @SerializedName("materialitems")
    private List<Materialitems> materialitems = null;

    @XmlElement(name = "inner")
    @SerializedName("extendProps")
    private Map<String, String> extendProps = null;

    @XmlElement(name = "remark")
    @SerializedName("remark")
    private String remark = null;

    @XmlElement(name = "processOrderCode")
    @SerializedName("processOrderCode")
    @Required
    private String processOrderCode = null;

    @XmlElement(name = "warehouseCode")
    @SerializedName("warehouseCode")
    @Required
    private String warehouseCode = null;

    public StoreProcessCreateRequest serviceType(String serviceType) {
        this.serviceType = serviceType;
        return this;
    }

    /**
     * 加工类型(1:仓内组合加工 2:仓内组合拆分)
     * @return serviceType
    **/

    public String getServiceType() {
        return serviceType;
    }

    public void setServiceType(String serviceType) {
        this.serviceType = serviceType;
    }

    public StoreProcessCreateRequest orderType(String orderType) {
        this.orderType = orderType;
        return this;
    }

    /**
     * 单据类型(CNJG&#x3D;仓内加工作业单)
     * @return orderType
    **/

    public String getOrderType() {
        return orderType;
    }

    public void setOrderType(String orderType) {
        this.orderType = orderType;
    }

    public StoreProcessCreateRequest planQty(Integer planQty) {
        this.planQty = planQty;
        return this;
    }

    /**
     * 成品计划数量
     * @return planQty
    **/

    public Integer getPlanQty() {
        return planQty;
    }

    public void setPlanQty(Integer planQty) {
        this.planQty = planQty;
    }

    public StoreProcessCreateRequest productItems(List<ProductItems> productItems) {
        this.productItems = productItems;
        return this;
    }

    public StoreProcessCreateRequest addProductItemsItem(ProductItems productItemsItem) {
        if (this.productItems == null) {
            this.productItems = new ArrayList<ProductItems>();
        }
        this.productItems.add(productItemsItem);
        return this;
    }

    /**
     * 商品列表
     * @return productItems
    **/

    public List<ProductItems> getProductItems() {
        return productItems;
    }

    public void setProductItems(List<ProductItems> productItems) {
        this.productItems = productItems;
    }

    public StoreProcessCreateRequest orderCreateTime(String orderCreateTime) {
        this.orderCreateTime = orderCreateTime;
        return this;
    }

    /**
     * 加工单创建时间(YYYY-MM-DD HH:MM:SS)
     * @return orderCreateTime
    **/

    public String getOrderCreateTime() {
        return orderCreateTime;
    }

    public void setOrderCreateTime(String orderCreateTime) {
        this.orderCreateTime = orderCreateTime;
    }

    public StoreProcessCreateRequest planTime(String planTime) {
        this.planTime = planTime;
        return this;
    }

    /**
     * 计划加工时间(YYYY-MM-DD HH:MM:SS)
     * @return planTime
    **/

    public String getPlanTime() {
        return planTime;
    }

    public void setPlanTime(String planTime) {
        this.planTime = planTime;
    }

    public StoreProcessCreateRequest materialitems(List<Materialitems> materialitems) {
        this.materialitems = materialitems;
        return this;
    }

    public StoreProcessCreateRequest addMaterialitemsItem(Materialitems materialitemsItem) {
        if (this.materialitems == null) {
            this.materialitems = new ArrayList<Materialitems>();
        }
        this.materialitems.add(materialitemsItem);
        return this;
    }

    /**
     * 加工商品列表
     * @return materialitems
    **/

    public List<Materialitems> getMaterialitems() {
        return materialitems;
    }

    public void setMaterialitems(List<Materialitems> materialitems) {
        this.materialitems = materialitems;
    }

    public StoreProcessCreateRequest extendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
        return this;
    }

    public StoreProcessCreateRequest putExtendPropsItem(String key, String extendPropsItem) {
        if (this.extendProps == null) {
            this.extendProps = new HashMap<String, String>();
        }
        this.extendProps.put(key, extendPropsItem);
        return this;
    }

    /**
     * 扩展属性(map类型)
     * @return extendProps
    **/

    public Map<String, String> getExtendProps() {
        return extendProps;
    }

    public void setExtendProps(Map<String, String> extendProps) {
        this.extendProps = extendProps;
    }

    public StoreProcessCreateRequest remark(String remark) {
        this.remark = remark;
        return this;
    }

    /**
     * 备注
     * @return remark
    **/

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public StoreProcessCreateRequest processOrderCode(String processOrderCode) {
        this.processOrderCode = processOrderCode;
        return this;
    }

    /**
     * 加工单编码
     * @return processOrderCode
    **/

    public String getProcessOrderCode() {
        return processOrderCode;
    }

    public void setProcessOrderCode(String processOrderCode) {
        this.processOrderCode = processOrderCode;
    }

    public StoreProcessCreateRequest warehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
        return this;
    }

    /**
     * 仓库编码(统仓统配等无需ERP指定仓储编码的情况填OTHER)
     * @return warehouseCode
    **/

    public String getWarehouseCode() {
        return warehouseCode;
    }

    public void setWarehouseCode(String warehouseCode) {
        this.warehouseCode = warehouseCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        StoreProcessCreateRequest storeProcessCreateRequest = (StoreProcessCreateRequest) o;
        return Objects.equals(this.serviceType, storeProcessCreateRequest.serviceType) &&
        Objects.equals(this.orderType, storeProcessCreateRequest.orderType) &&
        Objects.equals(this.planQty, storeProcessCreateRequest.planQty) &&
        Objects.equals(this.productItems, storeProcessCreateRequest.productItems) &&
        Objects.equals(this.orderCreateTime, storeProcessCreateRequest.orderCreateTime) &&
        Objects.equals(this.planTime, storeProcessCreateRequest.planTime) &&
        Objects.equals(this.materialitems, storeProcessCreateRequest.materialitems) &&
        Objects.equals(this.extendProps, storeProcessCreateRequest.extendProps) &&
        Objects.equals(this.remark, storeProcessCreateRequest.remark) &&
        Objects.equals(this.processOrderCode, storeProcessCreateRequest.processOrderCode) &&
        Objects.equals(this.warehouseCode, storeProcessCreateRequest.warehouseCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(serviceType, orderType, planQty, productItems, orderCreateTime, planTime, materialitems, extendProps, remark, processOrderCode, warehouseCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class StoreProcessCreateRequest {\n");
        
        sb.append("    serviceType: ").append(toIndentedString(serviceType)).append("\n");
        sb.append("    orderType: ").append(toIndentedString(orderType)).append("\n");
        sb.append("    planQty: ").append(toIndentedString(planQty)).append("\n");
        sb.append("    productItems: ").append(toIndentedString(productItems)).append("\n");
        sb.append("    orderCreateTime: ").append(toIndentedString(orderCreateTime)).append("\n");
        sb.append("    planTime: ").append(toIndentedString(planTime)).append("\n");
        sb.append("    materialitems: ").append(toIndentedString(materialitems)).append("\n");
        sb.append("    extendProps: ").append(toIndentedString(extendProps)).append("\n");
        sb.append("    remark: ").append(toIndentedString(remark)).append("\n");
        sb.append("    processOrderCode: ").append(toIndentedString(processOrderCode)).append("\n");
        sb.append("    warehouseCode: ").append(toIndentedString(warehouseCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

