/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufutransferordercreate;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import net.jdcloud.HufuStorage.model.jingdonghufutransferordercreate.TransferItems;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * TransferOrderCreateRequest
 */
@XmlRootElement(name = "TransferOrderCreateRequest")
@XmlAccessorType(XmlAccessType.FIELD)

public class TransferOrderCreateRequest implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "ownerCode")
    @SerializedName("ownerCode")
    private String ownerCode = null;

    @XmlElement(name = "fromStoreCode")
    @SerializedName("fromStoreCode")
    private String fromStoreCode = null;

    @XmlElement(name = "expectStartTime")
    @SerializedName("expectStartTime")
    private String expectStartTime = null;

    @XmlElement(name = "erpOrderCode")
    @SerializedName("erpOrderCode")
    private String erpOrderCode = null;

    @XmlElement(name = "attributes")
    @SerializedName("attributes")
    private String attributes = null;

    @XmlElementWrapper(name = "transferItems")
    @XmlElement(name = "transferItems")
    @SerializedName("transferItems")
    private List<TransferItems> transferItems = null;

    @XmlElement(name = "toStoreCode")
    @SerializedName("toStoreCode")
    private String toStoreCode = null;

    public TransferOrderCreateRequest ownerCode(String ownerCode) {
        this.ownerCode = ownerCode;
        return this;
    }

    /**
     * 货主编码
     * @return ownerCode
    **/

    public String getOwnerCode() {
        return ownerCode;
    }

    public void setOwnerCode(String ownerCode) {
        this.ownerCode = ownerCode;
    }

    public TransferOrderCreateRequest fromStoreCode(String fromStoreCode) {
        this.fromStoreCode = fromStoreCode;
        return this;
    }

    /**
     * 出库仓编码,Item1234,string(50),必填,
     * @return fromStoreCode
    **/

    public String getFromStoreCode() {
        return fromStoreCode;
    }

    public void setFromStoreCode(String fromStoreCode) {
        this.fromStoreCode = fromStoreCode;
    }

    public TransferOrderCreateRequest expectStartTime(String expectStartTime) {
        this.expectStartTime = expectStartTime;
        return this;
    }

    /**
     * 期望调拨开始时间,Item1234,string(50),,
     * @return expectStartTime
    **/

    public String getExpectStartTime() {
        return expectStartTime;
    }

    public void setExpectStartTime(String expectStartTime) {
        this.expectStartTime = expectStartTime;
    }

    public TransferOrderCreateRequest erpOrderCode(String erpOrderCode) {
        this.erpOrderCode = erpOrderCode;
        return this;
    }

    /**
     * 外部ERP订单号,HZ1234,string(50),必填,
     * @return erpOrderCode
    **/

    public String getErpOrderCode() {
        return erpOrderCode;
    }

    public void setErpOrderCode(String erpOrderCode) {
        this.erpOrderCode = erpOrderCode;
    }

    public TransferOrderCreateRequest attributes(String attributes) {
        this.attributes = attributes;
        return this;
    }

    /**
     * 扩展属性,HZ1234,string(500),,
     * @return attributes
    **/

    public String getAttributes() {
        return attributes;
    }

    public void setAttributes(String attributes) {
        this.attributes = attributes;
    }

    public TransferOrderCreateRequest transferItems(List<TransferItems> transferItems) {
        this.transferItems = transferItems;
        return this;
    }

    public TransferOrderCreateRequest addTransferItemsItem(TransferItems transferItemsItem) {
        if (this.transferItems == null) {
            this.transferItems = new ArrayList<TransferItems>();
        }
        this.transferItems.add(transferItemsItem);
        return this;
    }

    /**
     * 项目集
     * @return transferItems
    **/

    public List<TransferItems> getTransferItems() {
        return transferItems;
    }

    public void setTransferItems(List<TransferItems> transferItems) {
        this.transferItems = transferItems;
    }

    public TransferOrderCreateRequest toStoreCode(String toStoreCode) {
        this.toStoreCode = toStoreCode;
        return this;
    }

    /**
     * 入库仓编码,HZ1234,string(50),必填,
     * @return toStoreCode
    **/

    public String getToStoreCode() {
        return toStoreCode;
    }

    public void setToStoreCode(String toStoreCode) {
        this.toStoreCode = toStoreCode;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        TransferOrderCreateRequest transferOrderCreateRequest = (TransferOrderCreateRequest) o;
        return Objects.equals(this.ownerCode, transferOrderCreateRequest.ownerCode) &&
        Objects.equals(this.fromStoreCode, transferOrderCreateRequest.fromStoreCode) &&
        Objects.equals(this.expectStartTime, transferOrderCreateRequest.expectStartTime) &&
        Objects.equals(this.erpOrderCode, transferOrderCreateRequest.erpOrderCode) &&
        Objects.equals(this.attributes, transferOrderCreateRequest.attributes) &&
        Objects.equals(this.transferItems, transferOrderCreateRequest.transferItems) &&
        Objects.equals(this.toStoreCode, transferOrderCreateRequest.toStoreCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(ownerCode, fromStoreCode, expectStartTime, erpOrderCode, attributes, transferItems, toStoreCode);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class TransferOrderCreateRequest {\n");
        
        sb.append("    ownerCode: ").append(toIndentedString(ownerCode)).append("\n");
        sb.append("    fromStoreCode: ").append(toIndentedString(fromStoreCode)).append("\n");
        sb.append("    expectStartTime: ").append(toIndentedString(expectStartTime)).append("\n");
        sb.append("    erpOrderCode: ").append(toIndentedString(erpOrderCode)).append("\n");
        sb.append("    attributes: ").append(toIndentedString(attributes)).append("\n");
        sb.append("    transferItems: ").append(toIndentedString(transferItems)).append("\n");
        sb.append("    toStoreCode: ").append(toIndentedString(toStoreCode)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

