/*
 * Copyright 2018 JDCLOUD.COM
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http:#www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the jdcloud code generator program.
 */

package net.jdcloud.HufuStorage.model.jingdonghufutransferorderquery;

import com.jdcloud.sdk.apim.annotation.*;
import java.util.Objects;
import java.util.Arrays;
import java.io.Serializable;
import java.io.IOException;
import javax.xml.bind.annotation.*;
import com.google.gson.annotations.SerializedName;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * 调拨单货品明细
 */
@XmlRootElement(name = "transferOrderItems")
@XmlAccessorType(XmlAccessType.FIELD)

public class TransferOrderItems implements Serializable {

    private static final long serialVersionUID = 1L;

    @XmlElement(name = "inventoryType")
    @SerializedName("inventoryType")
    private String inventoryType = null;

    @XmlElement(name = "planCount")
    @SerializedName("planCount")
    private String planCount = null;

    @XmlElement(name = "outCount")
    @SerializedName("outCount")
    private String outCount = null;

    @XmlElement(name = "scItemCode")
    @SerializedName("scItemCode")
    private String scItemCode = null;

    @XmlElement(name = "inCount")
    @SerializedName("inCount")
    private String inCount = null;

    public TransferOrderItems inventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
        return this;
    }

    /**
     * 库存类型(1:可销售库存.101:残次),HZ1234,string(500),,
     * @return inventoryType
    **/

    public String getInventoryType() {
        return inventoryType;
    }

    public void setInventoryType(String inventoryType) {
        this.inventoryType = inventoryType;
    }

    public TransferOrderItems planCount(String planCount) {
        this.planCount = planCount;
        return this;
    }

    /**
     * 计划调拨数量,Item1234,string(50),,
     * @return planCount
    **/

    public String getPlanCount() {
        return planCount;
    }

    public void setPlanCount(String planCount) {
        this.planCount = planCount;
    }

    public TransferOrderItems outCount(String outCount) {
        this.outCount = outCount;
        return this;
    }

    /**
     * 实际出库数量,Item1234,string(50),,
     * @return outCount
    **/

    public String getOutCount() {
        return outCount;
    }

    public void setOutCount(String outCount) {
        this.outCount = outCount;
    }

    public TransferOrderItems scItemCode(String scItemCode) {
        this.scItemCode = scItemCode;
        return this;
    }

    /**
     * 货品编码,HZ1234,string(50),,
     * @return scItemCode
    **/

    public String getScItemCode() {
        return scItemCode;
    }

    public void setScItemCode(String scItemCode) {
        this.scItemCode = scItemCode;
    }

    public TransferOrderItems inCount(String inCount) {
        this.inCount = inCount;
        return this;
    }

    /**
     * 实际入库数量,Item1234,string(50),,
     * @return inCount
    **/

    public String getInCount() {
        return inCount;
    }

    public void setInCount(String inCount) {
        this.inCount = inCount;
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        TransferOrderItems transferOrderItems = (TransferOrderItems) o;
        return Objects.equals(this.inventoryType, transferOrderItems.inventoryType) &&
        Objects.equals(this.planCount, transferOrderItems.planCount) &&
        Objects.equals(this.outCount, transferOrderItems.outCount) &&
        Objects.equals(this.scItemCode, transferOrderItems.scItemCode) &&
        Objects.equals(this.inCount, transferOrderItems.inCount);
    }

    @Override
    public int hashCode() {
        return Objects.hash(inventoryType, planCount, outCount, scItemCode, inCount);
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class TransferOrderItems {\n");
        
        sb.append("    inventoryType: ").append(toIndentedString(inventoryType)).append("\n");
        sb.append("    planCount: ").append(toIndentedString(planCount)).append("\n");
        sb.append("    outCount: ").append(toIndentedString(outCount)).append("\n");
        sb.append("    scItemCode: ").append(toIndentedString(scItemCode)).append("\n");
        sb.append("    inCount: ").append(toIndentedString(inCount)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
          return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }

}

